// Code generated by go-swagger; DO NOT EDIT.

package operations

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/hashicorp/hcp/internal/pkg/api/releasesapi/models"
)

// ListProductsV1Reader is a Reader for the ListProductsV1 structure.
type ListProductsV1Reader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *ListProductsV1Reader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewListProductsV1OK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	default:
		result := NewListProductsV1Default(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewListProductsV1OK creates a ListProductsV1OK with default headers values
func NewListProductsV1OK() *ListProductsV1OK {
	return &ListProductsV1OK{}
}

/*
ListProductsV1OK describes a response with status code 200, with default header values.

OK (list retrieved)
*/
type ListProductsV1OK struct {

	/* The ETag for this resource
	 */
	ETag string

	Payload models.ProductListResponse
}

// IsSuccess returns true when this list products v1 o k response has a 2xx status code
func (o *ListProductsV1OK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this list products v1 o k response has a 3xx status code
func (o *ListProductsV1OK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this list products v1 o k response has a 4xx status code
func (o *ListProductsV1OK) IsClientError() bool {
	return false
}

// IsServerError returns true when this list products v1 o k response has a 5xx status code
func (o *ListProductsV1OK) IsServerError() bool {
	return false
}

// IsCode returns true when this list products v1 o k response a status code equal to that given
func (o *ListProductsV1OK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the list products v1 o k response
func (o *ListProductsV1OK) Code() int {
	return 200
}

func (o *ListProductsV1OK) Error() string {
	return fmt.Sprintf("[GET /v1/products][%d] listProductsV1OK  %+v", 200, o.Payload)
}

func (o *ListProductsV1OK) String() string {
	return fmt.Sprintf("[GET /v1/products][%d] listProductsV1OK  %+v", 200, o.Payload)
}

func (o *ListProductsV1OK) GetPayload() models.ProductListResponse {
	return o.Payload
}

func (o *ListProductsV1OK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header ETag
	hdrETag := response.GetHeader("ETag")

	if hdrETag != "" {
		o.ETag = hdrETag
	}

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewListProductsV1Default creates a ListProductsV1Default with default headers values
func NewListProductsV1Default(code int) *ListProductsV1Default {
	return &ListProductsV1Default{
		_statusCode: code,
	}
}

/*
ListProductsV1Default describes a response with status code -1, with default header values.

an error condition
*/
type ListProductsV1Default struct {
	_statusCode int

	Payload *models.Error
}

// IsSuccess returns true when this list products v1 default response has a 2xx status code
func (o *ListProductsV1Default) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this list products v1 default response has a 3xx status code
func (o *ListProductsV1Default) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this list products v1 default response has a 4xx status code
func (o *ListProductsV1Default) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this list products v1 default response has a 5xx status code
func (o *ListProductsV1Default) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this list products v1 default response a status code equal to that given
func (o *ListProductsV1Default) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the list products v1 default response
func (o *ListProductsV1Default) Code() int {
	return o._statusCode
}

func (o *ListProductsV1Default) Error() string {
	return fmt.Sprintf("[GET /v1/products][%d] listProductsV1 default  %+v", o._statusCode, o.Payload)
}

func (o *ListProductsV1Default) String() string {
	return fmt.Sprintf("[GET /v1/products][%d] listProductsV1 default  %+v", o._statusCode, o.Payload)
}

func (o *ListProductsV1Default) GetPayload() *models.Error {
	return o.Payload
}

func (o *ListProductsV1Default) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
