// Code generated by go-swagger; DO NOT EDIT.

package operations

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
)

// New creates a new operations API client.
func New(transport runtime.ClientTransport, formats strfmt.Registry) ClientService {
	return &Client{transport: transport, formats: formats}
}

/*
Client for operations API
*/
type Client struct {
	transport runtime.ClientTransport
	formats   strfmt.Registry
}

// ClientOption is the option for Client methods
type ClientOption func(*runtime.ClientOperation)

// ClientService is the interface for Client methods
type ClientService interface {
	GetReleaseV1(params *GetReleaseV1Params, opts ...ClientOption) (*GetReleaseV1OK, error)

	ListProductsV1(params *ListProductsV1Params, opts ...ClientOption) (*ListProductsV1OK, error)

	ListReleasesV1(params *ListReleasesV1Params, opts ...ClientOption) (*ListReleasesV1OK, error)

	SetTransport(transport runtime.ClientTransport)
}

/*
GetReleaseV1 gets the metadata for a specific product release

All metadata for a single product release is returned.
*/
func (a *Client) GetReleaseV1(params *GetReleaseV1Params, opts ...ClientOption) (*GetReleaseV1OK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetReleaseV1Params()
	}
	op := &runtime.ClientOperation{
		ID:                 "getReleaseV1",
		Method:             "GET",
		PathPattern:        "/v1/releases/{product}/{version}",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http", "https"},
		Params:             params,
		Reader:             &GetReleaseV1Reader{formats: a.formats},
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*GetReleaseV1OK)
	if ok {
		return success, nil
	}
	// unexpected success response
	unexpectedSuccess := result.(*GetReleaseV1Default)
	return nil, runtime.NewAPIError("unexpected success response: content available as default response in error", unexpectedSuccess, unexpectedSuccess.Code())
}

/*
ListProductsV1 lists product names

The names of all products on the releases site are returned.
*/
func (a *Client) ListProductsV1(params *ListProductsV1Params, opts ...ClientOption) (*ListProductsV1OK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewListProductsV1Params()
	}
	op := &runtime.ClientOperation{
		ID:                 "listProductsV1",
		Method:             "GET",
		PathPattern:        "/v1/products",
		ProducesMediaTypes: []string{"application/vnd+hashicorp.releases-api.v1+json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http", "https"},
		Params:             params,
		Reader:             &ListProductsV1Reader{formats: a.formats},
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*ListProductsV1OK)
	if ok {
		return success, nil
	}
	// unexpected success response
	unexpectedSuccess := result.(*ListProductsV1Default)
	return nil, runtime.NewAPIError("unexpected success response: content available as default response in error", unexpectedSuccess, unexpectedSuccess.Code())
}

/*
	ListReleasesV1 lists releases

	Get the release metadata for multiple releases.  This endpoint uses pagination for products

with many releases.  Results are ordered by release creation time from newest to oldest.
*/
func (a *Client) ListReleasesV1(params *ListReleasesV1Params, opts ...ClientOption) (*ListReleasesV1OK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewListReleasesV1Params()
	}
	op := &runtime.ClientOperation{
		ID:                 "listReleasesV1",
		Method:             "GET",
		PathPattern:        "/v1/releases/{product}",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http", "https"},
		Params:             params,
		Reader:             &ListReleasesV1Reader{formats: a.formats},
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*ListReleasesV1OK)
	if ok {
		return success, nil
	}
	// unexpected success response
	unexpectedSuccess := result.(*ListReleasesV1Default)
	return nil, runtime.NewAPIError("unexpected success response: content available as default response in error", unexpectedSuccess, unexpectedSuccess.Code())
}

// SetTransport changes the transport on the client
func (a *Client) SetTransport(transport runtime.ClientTransport) {
	a.transport = transport
}
