// Code generated by go-swagger; DO NOT EDIT.

package billing_account_service

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewBillingAccountServiceCreateSetupIntentParams creates a new BillingAccountServiceCreateSetupIntentParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewBillingAccountServiceCreateSetupIntentParams() *BillingAccountServiceCreateSetupIntentParams {
	return &BillingAccountServiceCreateSetupIntentParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewBillingAccountServiceCreateSetupIntentParamsWithTimeout creates a new BillingAccountServiceCreateSetupIntentParams object
// with the ability to set a timeout on a request.
func NewBillingAccountServiceCreateSetupIntentParamsWithTimeout(timeout time.Duration) *BillingAccountServiceCreateSetupIntentParams {
	return &BillingAccountServiceCreateSetupIntentParams{
		timeout: timeout,
	}
}

// NewBillingAccountServiceCreateSetupIntentParamsWithContext creates a new BillingAccountServiceCreateSetupIntentParams object
// with the ability to set a context for a request.
func NewBillingAccountServiceCreateSetupIntentParamsWithContext(ctx context.Context) *BillingAccountServiceCreateSetupIntentParams {
	return &BillingAccountServiceCreateSetupIntentParams{
		Context: ctx,
	}
}

// NewBillingAccountServiceCreateSetupIntentParamsWithHTTPClient creates a new BillingAccountServiceCreateSetupIntentParams object
// with the ability to set a custom HTTPClient for a request.
func NewBillingAccountServiceCreateSetupIntentParamsWithHTTPClient(client *http.Client) *BillingAccountServiceCreateSetupIntentParams {
	return &BillingAccountServiceCreateSetupIntentParams{
		HTTPClient: client,
	}
}

/*
BillingAccountServiceCreateSetupIntentParams contains all the parameters to send to the API endpoint

	for the billing account service create setup intent operation.

	Typically these are written to a http.Request.
*/
type BillingAccountServiceCreateSetupIntentParams struct {

	/* OrganizationID.

	     organization_id is the ID of the organization for which the client will
	collect payment details.
	*/
	OrganizationID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the billing account service create setup intent params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *BillingAccountServiceCreateSetupIntentParams) WithDefaults() *BillingAccountServiceCreateSetupIntentParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the billing account service create setup intent params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *BillingAccountServiceCreateSetupIntentParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the billing account service create setup intent params
func (o *BillingAccountServiceCreateSetupIntentParams) WithTimeout(timeout time.Duration) *BillingAccountServiceCreateSetupIntentParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the billing account service create setup intent params
func (o *BillingAccountServiceCreateSetupIntentParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the billing account service create setup intent params
func (o *BillingAccountServiceCreateSetupIntentParams) WithContext(ctx context.Context) *BillingAccountServiceCreateSetupIntentParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the billing account service create setup intent params
func (o *BillingAccountServiceCreateSetupIntentParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the billing account service create setup intent params
func (o *BillingAccountServiceCreateSetupIntentParams) WithHTTPClient(client *http.Client) *BillingAccountServiceCreateSetupIntentParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the billing account service create setup intent params
func (o *BillingAccountServiceCreateSetupIntentParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithOrganizationID adds the organizationID to the billing account service create setup intent params
func (o *BillingAccountServiceCreateSetupIntentParams) WithOrganizationID(organizationID string) *BillingAccountServiceCreateSetupIntentParams {
	o.SetOrganizationID(organizationID)
	return o
}

// SetOrganizationID adds the organizationId to the billing account service create setup intent params
func (o *BillingAccountServiceCreateSetupIntentParams) SetOrganizationID(organizationID string) {
	o.OrganizationID = organizationID
}

// WriteToRequest writes these params to a swagger request
func (o *BillingAccountServiceCreateSetupIntentParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param organization_id
	if err := r.SetPathParam("organization_id", o.OrganizationID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
