// Code generated by go-swagger; DO NOT EDIT.

package f_c_p_management_service

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewFCPManagementServiceListConsumptionPoolsParams creates a new FCPManagementServiceListConsumptionPoolsParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewFCPManagementServiceListConsumptionPoolsParams() *FCPManagementServiceListConsumptionPoolsParams {
	return &FCPManagementServiceListConsumptionPoolsParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewFCPManagementServiceListConsumptionPoolsParamsWithTimeout creates a new FCPManagementServiceListConsumptionPoolsParams object
// with the ability to set a timeout on a request.
func NewFCPManagementServiceListConsumptionPoolsParamsWithTimeout(timeout time.Duration) *FCPManagementServiceListConsumptionPoolsParams {
	return &FCPManagementServiceListConsumptionPoolsParams{
		timeout: timeout,
	}
}

// NewFCPManagementServiceListConsumptionPoolsParamsWithContext creates a new FCPManagementServiceListConsumptionPoolsParams object
// with the ability to set a context for a request.
func NewFCPManagementServiceListConsumptionPoolsParamsWithContext(ctx context.Context) *FCPManagementServiceListConsumptionPoolsParams {
	return &FCPManagementServiceListConsumptionPoolsParams{
		Context: ctx,
	}
}

// NewFCPManagementServiceListConsumptionPoolsParamsWithHTTPClient creates a new FCPManagementServiceListConsumptionPoolsParams object
// with the ability to set a custom HTTPClient for a request.
func NewFCPManagementServiceListConsumptionPoolsParamsWithHTTPClient(client *http.Client) *FCPManagementServiceListConsumptionPoolsParams {
	return &FCPManagementServiceListConsumptionPoolsParams{
		HTTPClient: client,
	}
}

/*
FCPManagementServiceListConsumptionPoolsParams contains all the parameters to send to the API endpoint

	for the f c p management service list consumption pools operation.

	Typically these are written to a http.Request.
*/
type FCPManagementServiceListConsumptionPoolsParams struct {

	/* BillingAccountID.

	   billing_account_id is the billing account to fetch consumption pools for.
	*/
	BillingAccountID string

	/* OrganizationID.

	   organization_id is the organization where the billing account belongs to.
	*/
	OrganizationID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the f c p management service list consumption pools params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *FCPManagementServiceListConsumptionPoolsParams) WithDefaults() *FCPManagementServiceListConsumptionPoolsParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the f c p management service list consumption pools params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *FCPManagementServiceListConsumptionPoolsParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the f c p management service list consumption pools params
func (o *FCPManagementServiceListConsumptionPoolsParams) WithTimeout(timeout time.Duration) *FCPManagementServiceListConsumptionPoolsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the f c p management service list consumption pools params
func (o *FCPManagementServiceListConsumptionPoolsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the f c p management service list consumption pools params
func (o *FCPManagementServiceListConsumptionPoolsParams) WithContext(ctx context.Context) *FCPManagementServiceListConsumptionPoolsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the f c p management service list consumption pools params
func (o *FCPManagementServiceListConsumptionPoolsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the f c p management service list consumption pools params
func (o *FCPManagementServiceListConsumptionPoolsParams) WithHTTPClient(client *http.Client) *FCPManagementServiceListConsumptionPoolsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the f c p management service list consumption pools params
func (o *FCPManagementServiceListConsumptionPoolsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBillingAccountID adds the billingAccountID to the f c p management service list consumption pools params
func (o *FCPManagementServiceListConsumptionPoolsParams) WithBillingAccountID(billingAccountID string) *FCPManagementServiceListConsumptionPoolsParams {
	o.SetBillingAccountID(billingAccountID)
	return o
}

// SetBillingAccountID adds the billingAccountId to the f c p management service list consumption pools params
func (o *FCPManagementServiceListConsumptionPoolsParams) SetBillingAccountID(billingAccountID string) {
	o.BillingAccountID = billingAccountID
}

// WithOrganizationID adds the organizationID to the f c p management service list consumption pools params
func (o *FCPManagementServiceListConsumptionPoolsParams) WithOrganizationID(organizationID string) *FCPManagementServiceListConsumptionPoolsParams {
	o.SetOrganizationID(organizationID)
	return o
}

// SetOrganizationID adds the organizationId to the f c p management service list consumption pools params
func (o *FCPManagementServiceListConsumptionPoolsParams) SetOrganizationID(organizationID string) {
	o.OrganizationID = organizationID
}

// WriteToRequest writes these params to a swagger request
func (o *FCPManagementServiceListConsumptionPoolsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param billing_account_id
	if err := r.SetPathParam("billing_account_id", o.BillingAccountID); err != nil {
		return err
	}

	// path param organization_id
	if err := r.SetPathParam("organization_id", o.OrganizationID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
