// Code generated by go-swagger; DO NOT EDIT.

package statement_service

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewStatementServiceGetRunningStatementParams creates a new StatementServiceGetRunningStatementParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewStatementServiceGetRunningStatementParams() *StatementServiceGetRunningStatementParams {
	return &StatementServiceGetRunningStatementParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewStatementServiceGetRunningStatementParamsWithTimeout creates a new StatementServiceGetRunningStatementParams object
// with the ability to set a timeout on a request.
func NewStatementServiceGetRunningStatementParamsWithTimeout(timeout time.Duration) *StatementServiceGetRunningStatementParams {
	return &StatementServiceGetRunningStatementParams{
		timeout: timeout,
	}
}

// NewStatementServiceGetRunningStatementParamsWithContext creates a new StatementServiceGetRunningStatementParams object
// with the ability to set a context for a request.
func NewStatementServiceGetRunningStatementParamsWithContext(ctx context.Context) *StatementServiceGetRunningStatementParams {
	return &StatementServiceGetRunningStatementParams{
		Context: ctx,
	}
}

// NewStatementServiceGetRunningStatementParamsWithHTTPClient creates a new StatementServiceGetRunningStatementParams object
// with the ability to set a custom HTTPClient for a request.
func NewStatementServiceGetRunningStatementParamsWithHTTPClient(client *http.Client) *StatementServiceGetRunningStatementParams {
	return &StatementServiceGetRunningStatementParams{
		HTTPClient: client,
	}
}

/*
StatementServiceGetRunningStatementParams contains all the parameters to send to the API endpoint

	for the statement service get running statement operation.

	Typically these are written to a http.Request.
*/
type StatementServiceGetRunningStatementParams struct {

	/* BillingAccountID.

	     id is the user-settable ID that uniquely identifies the Billing Account
	within the organization.
	*/
	BillingAccountID string

	/* OrganizationID.

	     organization_id is the ID of the organization to which the Billing Account
	belongs.
	*/
	OrganizationID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the statement service get running statement params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *StatementServiceGetRunningStatementParams) WithDefaults() *StatementServiceGetRunningStatementParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the statement service get running statement params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *StatementServiceGetRunningStatementParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the statement service get running statement params
func (o *StatementServiceGetRunningStatementParams) WithTimeout(timeout time.Duration) *StatementServiceGetRunningStatementParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the statement service get running statement params
func (o *StatementServiceGetRunningStatementParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the statement service get running statement params
func (o *StatementServiceGetRunningStatementParams) WithContext(ctx context.Context) *StatementServiceGetRunningStatementParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the statement service get running statement params
func (o *StatementServiceGetRunningStatementParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the statement service get running statement params
func (o *StatementServiceGetRunningStatementParams) WithHTTPClient(client *http.Client) *StatementServiceGetRunningStatementParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the statement service get running statement params
func (o *StatementServiceGetRunningStatementParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBillingAccountID adds the billingAccountID to the statement service get running statement params
func (o *StatementServiceGetRunningStatementParams) WithBillingAccountID(billingAccountID string) *StatementServiceGetRunningStatementParams {
	o.SetBillingAccountID(billingAccountID)
	return o
}

// SetBillingAccountID adds the billingAccountId to the statement service get running statement params
func (o *StatementServiceGetRunningStatementParams) SetBillingAccountID(billingAccountID string) {
	o.BillingAccountID = billingAccountID
}

// WithOrganizationID adds the organizationID to the statement service get running statement params
func (o *StatementServiceGetRunningStatementParams) WithOrganizationID(organizationID string) *StatementServiceGetRunningStatementParams {
	o.SetOrganizationID(organizationID)
	return o
}

// SetOrganizationID adds the organizationId to the statement service get running statement params
func (o *StatementServiceGetRunningStatementParams) SetOrganizationID(organizationID string) {
	o.OrganizationID = organizationID
}

// WriteToRequest writes these params to a swagger request
func (o *StatementServiceGetRunningStatementParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param billing_account_id
	if err := r.SetPathParam("billing_account_id", o.BillingAccountID); err != nil {
		return err
	}

	// path param organization_id
	if err := r.SetPathParam("organization_id", o.OrganizationID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
