// Code generated by go-swagger; DO NOT EDIT.

package auth_config_service

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewAuthConfigServiceEditAuthConnectionParams creates a new AuthConfigServiceEditAuthConnectionParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewAuthConfigServiceEditAuthConnectionParams() *AuthConfigServiceEditAuthConnectionParams {
	return &AuthConfigServiceEditAuthConnectionParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewAuthConfigServiceEditAuthConnectionParamsWithTimeout creates a new AuthConfigServiceEditAuthConnectionParams object
// with the ability to set a timeout on a request.
func NewAuthConfigServiceEditAuthConnectionParamsWithTimeout(timeout time.Duration) *AuthConfigServiceEditAuthConnectionParams {
	return &AuthConfigServiceEditAuthConnectionParams{
		timeout: timeout,
	}
}

// NewAuthConfigServiceEditAuthConnectionParamsWithContext creates a new AuthConfigServiceEditAuthConnectionParams object
// with the ability to set a context for a request.
func NewAuthConfigServiceEditAuthConnectionParamsWithContext(ctx context.Context) *AuthConfigServiceEditAuthConnectionParams {
	return &AuthConfigServiceEditAuthConnectionParams{
		Context: ctx,
	}
}

// NewAuthConfigServiceEditAuthConnectionParamsWithHTTPClient creates a new AuthConfigServiceEditAuthConnectionParams object
// with the ability to set a custom HTTPClient for a request.
func NewAuthConfigServiceEditAuthConnectionParamsWithHTTPClient(client *http.Client) *AuthConfigServiceEditAuthConnectionParams {
	return &AuthConfigServiceEditAuthConnectionParams{
		HTTPClient: client,
	}
}

/*
AuthConfigServiceEditAuthConnectionParams contains all the parameters to send to the API endpoint

	for the auth config service edit auth connection operation.

	Typically these are written to a http.Request.
*/
type AuthConfigServiceEditAuthConnectionParams struct {

	// Body.
	Body AuthConfigServiceEditAuthConnectionBody

	/* OrganizationID.

	   id of the organization that owns  the connection
	*/
	OrganizationID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the auth config service edit auth connection params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *AuthConfigServiceEditAuthConnectionParams) WithDefaults() *AuthConfigServiceEditAuthConnectionParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the auth config service edit auth connection params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *AuthConfigServiceEditAuthConnectionParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the auth config service edit auth connection params
func (o *AuthConfigServiceEditAuthConnectionParams) WithTimeout(timeout time.Duration) *AuthConfigServiceEditAuthConnectionParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the auth config service edit auth connection params
func (o *AuthConfigServiceEditAuthConnectionParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the auth config service edit auth connection params
func (o *AuthConfigServiceEditAuthConnectionParams) WithContext(ctx context.Context) *AuthConfigServiceEditAuthConnectionParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the auth config service edit auth connection params
func (o *AuthConfigServiceEditAuthConnectionParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the auth config service edit auth connection params
func (o *AuthConfigServiceEditAuthConnectionParams) WithHTTPClient(client *http.Client) *AuthConfigServiceEditAuthConnectionParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the auth config service edit auth connection params
func (o *AuthConfigServiceEditAuthConnectionParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the auth config service edit auth connection params
func (o *AuthConfigServiceEditAuthConnectionParams) WithBody(body AuthConfigServiceEditAuthConnectionBody) *AuthConfigServiceEditAuthConnectionParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the auth config service edit auth connection params
func (o *AuthConfigServiceEditAuthConnectionParams) SetBody(body AuthConfigServiceEditAuthConnectionBody) {
	o.Body = body
}

// WithOrganizationID adds the organizationID to the auth config service edit auth connection params
func (o *AuthConfigServiceEditAuthConnectionParams) WithOrganizationID(organizationID string) *AuthConfigServiceEditAuthConnectionParams {
	o.SetOrganizationID(organizationID)
	return o
}

// SetOrganizationID adds the organizationId to the auth config service edit auth connection params
func (o *AuthConfigServiceEditAuthConnectionParams) SetOrganizationID(organizationID string) {
	o.OrganizationID = organizationID
}

// WriteToRequest writes these params to a swagger request
func (o *AuthConfigServiceEditAuthConnectionParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if err := r.SetBodyParam(o.Body); err != nil {
		return err
	}

	// path param organization_id
	if err := r.SetPathParam("organization_id", o.OrganizationID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
