// Code generated by go-swagger; DO NOT EDIT.

package groups_service

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewGroupsServiceCreateGroupParams creates a new GroupsServiceCreateGroupParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewGroupsServiceCreateGroupParams() *GroupsServiceCreateGroupParams {
	return &GroupsServiceCreateGroupParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewGroupsServiceCreateGroupParamsWithTimeout creates a new GroupsServiceCreateGroupParams object
// with the ability to set a timeout on a request.
func NewGroupsServiceCreateGroupParamsWithTimeout(timeout time.Duration) *GroupsServiceCreateGroupParams {
	return &GroupsServiceCreateGroupParams{
		timeout: timeout,
	}
}

// NewGroupsServiceCreateGroupParamsWithContext creates a new GroupsServiceCreateGroupParams object
// with the ability to set a context for a request.
func NewGroupsServiceCreateGroupParamsWithContext(ctx context.Context) *GroupsServiceCreateGroupParams {
	return &GroupsServiceCreateGroupParams{
		Context: ctx,
	}
}

// NewGroupsServiceCreateGroupParamsWithHTTPClient creates a new GroupsServiceCreateGroupParams object
// with the ability to set a custom HTTPClient for a request.
func NewGroupsServiceCreateGroupParamsWithHTTPClient(client *http.Client) *GroupsServiceCreateGroupParams {
	return &GroupsServiceCreateGroupParams{
		HTTPClient: client,
	}
}

/*
GroupsServiceCreateGroupParams contains all the parameters to send to the API endpoint

	for the groups service create group operation.

	Typically these are written to a http.Request.
*/
type GroupsServiceCreateGroupParams struct {

	// Body.
	Body GroupsServiceCreateGroupBody

	/* ParentResourceName.

	     parent_resource is the parent resource of the group.
	organization/<org_id>
	*/
	ParentResourceName string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the groups service create group params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GroupsServiceCreateGroupParams) WithDefaults() *GroupsServiceCreateGroupParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the groups service create group params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GroupsServiceCreateGroupParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the groups service create group params
func (o *GroupsServiceCreateGroupParams) WithTimeout(timeout time.Duration) *GroupsServiceCreateGroupParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the groups service create group params
func (o *GroupsServiceCreateGroupParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the groups service create group params
func (o *GroupsServiceCreateGroupParams) WithContext(ctx context.Context) *GroupsServiceCreateGroupParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the groups service create group params
func (o *GroupsServiceCreateGroupParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the groups service create group params
func (o *GroupsServiceCreateGroupParams) WithHTTPClient(client *http.Client) *GroupsServiceCreateGroupParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the groups service create group params
func (o *GroupsServiceCreateGroupParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the groups service create group params
func (o *GroupsServiceCreateGroupParams) WithBody(body GroupsServiceCreateGroupBody) *GroupsServiceCreateGroupParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the groups service create group params
func (o *GroupsServiceCreateGroupParams) SetBody(body GroupsServiceCreateGroupBody) {
	o.Body = body
}

// WithParentResourceName adds the parentResourceName to the groups service create group params
func (o *GroupsServiceCreateGroupParams) WithParentResourceName(parentResourceName string) *GroupsServiceCreateGroupParams {
	o.SetParentResourceName(parentResourceName)
	return o
}

// SetParentResourceName adds the parentResourceName to the groups service create group params
func (o *GroupsServiceCreateGroupParams) SetParentResourceName(parentResourceName string) {
	o.ParentResourceName = parentResourceName
}

// WriteToRequest writes these params to a swagger request
func (o *GroupsServiceCreateGroupParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if err := r.SetBodyParam(o.Body); err != nil {
		return err
	}

	// path param parent_resource_name
	if err := r.SetPathParam("parent_resource_name", o.ParentResourceName); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
