// Code generated by go-swagger; DO NOT EDIT.

package invitations_service

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/hashicorp/hcp-sdk-go/clients/cloud-iam/stable/2019-12-10/models"
)

// NewInvitationsServiceAcceptOrganizationInvitationParams creates a new InvitationsServiceAcceptOrganizationInvitationParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewInvitationsServiceAcceptOrganizationInvitationParams() *InvitationsServiceAcceptOrganizationInvitationParams {
	return &InvitationsServiceAcceptOrganizationInvitationParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewInvitationsServiceAcceptOrganizationInvitationParamsWithTimeout creates a new InvitationsServiceAcceptOrganizationInvitationParams object
// with the ability to set a timeout on a request.
func NewInvitationsServiceAcceptOrganizationInvitationParamsWithTimeout(timeout time.Duration) *InvitationsServiceAcceptOrganizationInvitationParams {
	return &InvitationsServiceAcceptOrganizationInvitationParams{
		timeout: timeout,
	}
}

// NewInvitationsServiceAcceptOrganizationInvitationParamsWithContext creates a new InvitationsServiceAcceptOrganizationInvitationParams object
// with the ability to set a context for a request.
func NewInvitationsServiceAcceptOrganizationInvitationParamsWithContext(ctx context.Context) *InvitationsServiceAcceptOrganizationInvitationParams {
	return &InvitationsServiceAcceptOrganizationInvitationParams{
		Context: ctx,
	}
}

// NewInvitationsServiceAcceptOrganizationInvitationParamsWithHTTPClient creates a new InvitationsServiceAcceptOrganizationInvitationParams object
// with the ability to set a custom HTTPClient for a request.
func NewInvitationsServiceAcceptOrganizationInvitationParamsWithHTTPClient(client *http.Client) *InvitationsServiceAcceptOrganizationInvitationParams {
	return &InvitationsServiceAcceptOrganizationInvitationParams{
		HTTPClient: client,
	}
}

/*
InvitationsServiceAcceptOrganizationInvitationParams contains all the parameters to send to the API endpoint

	for the invitations service accept organization invitation operation.

	Typically these are written to a http.Request.
*/
type InvitationsServiceAcceptOrganizationInvitationParams struct {

	/* Body.

	   AcceptOrganizationInvitationRequest is a request to accept an organization invitation.
	*/
	Body *models.HashicorpCloudIamAcceptOrganizationInvitationRequest

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the invitations service accept organization invitation params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *InvitationsServiceAcceptOrganizationInvitationParams) WithDefaults() *InvitationsServiceAcceptOrganizationInvitationParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the invitations service accept organization invitation params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *InvitationsServiceAcceptOrganizationInvitationParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the invitations service accept organization invitation params
func (o *InvitationsServiceAcceptOrganizationInvitationParams) WithTimeout(timeout time.Duration) *InvitationsServiceAcceptOrganizationInvitationParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the invitations service accept organization invitation params
func (o *InvitationsServiceAcceptOrganizationInvitationParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the invitations service accept organization invitation params
func (o *InvitationsServiceAcceptOrganizationInvitationParams) WithContext(ctx context.Context) *InvitationsServiceAcceptOrganizationInvitationParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the invitations service accept organization invitation params
func (o *InvitationsServiceAcceptOrganizationInvitationParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the invitations service accept organization invitation params
func (o *InvitationsServiceAcceptOrganizationInvitationParams) WithHTTPClient(client *http.Client) *InvitationsServiceAcceptOrganizationInvitationParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the invitations service accept organization invitation params
func (o *InvitationsServiceAcceptOrganizationInvitationParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the invitations service accept organization invitation params
func (o *InvitationsServiceAcceptOrganizationInvitationParams) WithBody(body *models.HashicorpCloudIamAcceptOrganizationInvitationRequest) *InvitationsServiceAcceptOrganizationInvitationParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the invitations service accept organization invitation params
func (o *InvitationsServiceAcceptOrganizationInvitationParams) SetBody(body *models.HashicorpCloudIamAcceptOrganizationInvitationRequest) {
	o.Body = body
}

// WriteToRequest writes these params to a swagger request
func (o *InvitationsServiceAcceptOrganizationInvitationParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
