// Code generated by go-swagger; DO NOT EDIT.

package secret_service

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewDeleteAppParams creates a new DeleteAppParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewDeleteAppParams() *DeleteAppParams {
	return &DeleteAppParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewDeleteAppParamsWithTimeout creates a new DeleteAppParams object
// with the ability to set a timeout on a request.
func NewDeleteAppParamsWithTimeout(timeout time.Duration) *DeleteAppParams {
	return &DeleteAppParams{
		timeout: timeout,
	}
}

// NewDeleteAppParamsWithContext creates a new DeleteAppParams object
// with the ability to set a context for a request.
func NewDeleteAppParamsWithContext(ctx context.Context) *DeleteAppParams {
	return &DeleteAppParams{
		Context: ctx,
	}
}

// NewDeleteAppParamsWithHTTPClient creates a new DeleteAppParams object
// with the ability to set a custom HTTPClient for a request.
func NewDeleteAppParamsWithHTTPClient(client *http.Client) *DeleteAppParams {
	return &DeleteAppParams{
		HTTPClient: client,
	}
}

/*
DeleteAppParams contains all the parameters to send to the API endpoint

	for the delete app operation.

	Typically these are written to a http.Request.
*/
type DeleteAppParams struct {

	// Name.
	Name string

	// OrganizationID.
	OrganizationID string

	// ProjectID.
	ProjectID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the delete app params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *DeleteAppParams) WithDefaults() *DeleteAppParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the delete app params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *DeleteAppParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the delete app params
func (o *DeleteAppParams) WithTimeout(timeout time.Duration) *DeleteAppParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the delete app params
func (o *DeleteAppParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the delete app params
func (o *DeleteAppParams) WithContext(ctx context.Context) *DeleteAppParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the delete app params
func (o *DeleteAppParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the delete app params
func (o *DeleteAppParams) WithHTTPClient(client *http.Client) *DeleteAppParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the delete app params
func (o *DeleteAppParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithName adds the name to the delete app params
func (o *DeleteAppParams) WithName(name string) *DeleteAppParams {
	o.SetName(name)
	return o
}

// SetName adds the name to the delete app params
func (o *DeleteAppParams) SetName(name string) {
	o.Name = name
}

// WithOrganizationID adds the organizationID to the delete app params
func (o *DeleteAppParams) WithOrganizationID(organizationID string) *DeleteAppParams {
	o.SetOrganizationID(organizationID)
	return o
}

// SetOrganizationID adds the organizationId to the delete app params
func (o *DeleteAppParams) SetOrganizationID(organizationID string) {
	o.OrganizationID = organizationID
}

// WithProjectID adds the projectID to the delete app params
func (o *DeleteAppParams) WithProjectID(projectID string) *DeleteAppParams {
	o.SetProjectID(projectID)
	return o
}

// SetProjectID adds the projectId to the delete app params
func (o *DeleteAppParams) SetProjectID(projectID string) {
	o.ProjectID = projectID
}

// WriteToRequest writes these params to a swagger request
func (o *DeleteAppParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param name
	if err := r.SetPathParam("name", o.Name); err != nil {
		return err
	}

	// path param organization_id
	if err := r.SetPathParam("organization_id", o.OrganizationID); err != nil {
		return err
	}

	// path param project_id
	if err := r.SetPathParam("project_id", o.ProjectID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
