// Code generated by go-swagger; DO NOT EDIT.

package secret_service

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewDeleteAzureIntegrationParams creates a new DeleteAzureIntegrationParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewDeleteAzureIntegrationParams() *DeleteAzureIntegrationParams {
	return &DeleteAzureIntegrationParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewDeleteAzureIntegrationParamsWithTimeout creates a new DeleteAzureIntegrationParams object
// with the ability to set a timeout on a request.
func NewDeleteAzureIntegrationParamsWithTimeout(timeout time.Duration) *DeleteAzureIntegrationParams {
	return &DeleteAzureIntegrationParams{
		timeout: timeout,
	}
}

// NewDeleteAzureIntegrationParamsWithContext creates a new DeleteAzureIntegrationParams object
// with the ability to set a context for a request.
func NewDeleteAzureIntegrationParamsWithContext(ctx context.Context) *DeleteAzureIntegrationParams {
	return &DeleteAzureIntegrationParams{
		Context: ctx,
	}
}

// NewDeleteAzureIntegrationParamsWithHTTPClient creates a new DeleteAzureIntegrationParams object
// with the ability to set a custom HTTPClient for a request.
func NewDeleteAzureIntegrationParamsWithHTTPClient(client *http.Client) *DeleteAzureIntegrationParams {
	return &DeleteAzureIntegrationParams{
		HTTPClient: client,
	}
}

/*
DeleteAzureIntegrationParams contains all the parameters to send to the API endpoint

	for the delete azure integration operation.

	Typically these are written to a http.Request.
*/
type DeleteAzureIntegrationParams struct {

	// Name.
	Name string

	// OrganizationID.
	OrganizationID string

	// ProjectID.
	ProjectID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the delete azure integration params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *DeleteAzureIntegrationParams) WithDefaults() *DeleteAzureIntegrationParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the delete azure integration params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *DeleteAzureIntegrationParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the delete azure integration params
func (o *DeleteAzureIntegrationParams) WithTimeout(timeout time.Duration) *DeleteAzureIntegrationParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the delete azure integration params
func (o *DeleteAzureIntegrationParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the delete azure integration params
func (o *DeleteAzureIntegrationParams) WithContext(ctx context.Context) *DeleteAzureIntegrationParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the delete azure integration params
func (o *DeleteAzureIntegrationParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the delete azure integration params
func (o *DeleteAzureIntegrationParams) WithHTTPClient(client *http.Client) *DeleteAzureIntegrationParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the delete azure integration params
func (o *DeleteAzureIntegrationParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithName adds the name to the delete azure integration params
func (o *DeleteAzureIntegrationParams) WithName(name string) *DeleteAzureIntegrationParams {
	o.SetName(name)
	return o
}

// SetName adds the name to the delete azure integration params
func (o *DeleteAzureIntegrationParams) SetName(name string) {
	o.Name = name
}

// WithOrganizationID adds the organizationID to the delete azure integration params
func (o *DeleteAzureIntegrationParams) WithOrganizationID(organizationID string) *DeleteAzureIntegrationParams {
	o.SetOrganizationID(organizationID)
	return o
}

// SetOrganizationID adds the organizationId to the delete azure integration params
func (o *DeleteAzureIntegrationParams) SetOrganizationID(organizationID string) {
	o.OrganizationID = organizationID
}

// WithProjectID adds the projectID to the delete azure integration params
func (o *DeleteAzureIntegrationParams) WithProjectID(projectID string) *DeleteAzureIntegrationParams {
	o.SetProjectID(projectID)
	return o
}

// SetProjectID adds the projectId to the delete azure integration params
func (o *DeleteAzureIntegrationParams) SetProjectID(projectID string) {
	o.ProjectID = projectID
}

// WriteToRequest writes these params to a swagger request
func (o *DeleteAzureIntegrationParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param name
	if err := r.SetPathParam("name", o.Name); err != nil {
		return err
	}

	// path param organization_id
	if err := r.SetPathParam("organization_id", o.OrganizationID); err != nil {
		return err
	}

	// path param project_id
	if err := r.SetPathParam("project_id", o.ProjectID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
