// Code generated by go-swagger; DO NOT EDIT.

package secret_service

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewDeleteGatewayPoolParams creates a new DeleteGatewayPoolParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewDeleteGatewayPoolParams() *DeleteGatewayPoolParams {
	return &DeleteGatewayPoolParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewDeleteGatewayPoolParamsWithTimeout creates a new DeleteGatewayPoolParams object
// with the ability to set a timeout on a request.
func NewDeleteGatewayPoolParamsWithTimeout(timeout time.Duration) *DeleteGatewayPoolParams {
	return &DeleteGatewayPoolParams{
		timeout: timeout,
	}
}

// NewDeleteGatewayPoolParamsWithContext creates a new DeleteGatewayPoolParams object
// with the ability to set a context for a request.
func NewDeleteGatewayPoolParamsWithContext(ctx context.Context) *DeleteGatewayPoolParams {
	return &DeleteGatewayPoolParams{
		Context: ctx,
	}
}

// NewDeleteGatewayPoolParamsWithHTTPClient creates a new DeleteGatewayPoolParams object
// with the ability to set a custom HTTPClient for a request.
func NewDeleteGatewayPoolParamsWithHTTPClient(client *http.Client) *DeleteGatewayPoolParams {
	return &DeleteGatewayPoolParams{
		HTTPClient: client,
	}
}

/*
DeleteGatewayPoolParams contains all the parameters to send to the API endpoint

	for the delete gateway pool operation.

	Typically these are written to a http.Request.
*/
type DeleteGatewayPoolParams struct {

	// GatewayPoolName.
	GatewayPoolName string

	// OrganizationID.
	OrganizationID string

	// ProjectID.
	ProjectID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the delete gateway pool params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *DeleteGatewayPoolParams) WithDefaults() *DeleteGatewayPoolParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the delete gateway pool params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *DeleteGatewayPoolParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the delete gateway pool params
func (o *DeleteGatewayPoolParams) WithTimeout(timeout time.Duration) *DeleteGatewayPoolParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the delete gateway pool params
func (o *DeleteGatewayPoolParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the delete gateway pool params
func (o *DeleteGatewayPoolParams) WithContext(ctx context.Context) *DeleteGatewayPoolParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the delete gateway pool params
func (o *DeleteGatewayPoolParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the delete gateway pool params
func (o *DeleteGatewayPoolParams) WithHTTPClient(client *http.Client) *DeleteGatewayPoolParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the delete gateway pool params
func (o *DeleteGatewayPoolParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithGatewayPoolName adds the gatewayPoolName to the delete gateway pool params
func (o *DeleteGatewayPoolParams) WithGatewayPoolName(gatewayPoolName string) *DeleteGatewayPoolParams {
	o.SetGatewayPoolName(gatewayPoolName)
	return o
}

// SetGatewayPoolName adds the gatewayPoolName to the delete gateway pool params
func (o *DeleteGatewayPoolParams) SetGatewayPoolName(gatewayPoolName string) {
	o.GatewayPoolName = gatewayPoolName
}

// WithOrganizationID adds the organizationID to the delete gateway pool params
func (o *DeleteGatewayPoolParams) WithOrganizationID(organizationID string) *DeleteGatewayPoolParams {
	o.SetOrganizationID(organizationID)
	return o
}

// SetOrganizationID adds the organizationId to the delete gateway pool params
func (o *DeleteGatewayPoolParams) SetOrganizationID(organizationID string) {
	o.OrganizationID = organizationID
}

// WithProjectID adds the projectID to the delete gateway pool params
func (o *DeleteGatewayPoolParams) WithProjectID(projectID string) *DeleteGatewayPoolParams {
	o.SetProjectID(projectID)
	return o
}

// SetProjectID adds the projectId to the delete gateway pool params
func (o *DeleteGatewayPoolParams) SetProjectID(projectID string) {
	o.ProjectID = projectID
}

// WriteToRequest writes these params to a swagger request
func (o *DeleteGatewayPoolParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param gateway_pool_name
	if err := r.SetPathParam("gateway_pool_name", o.GatewayPoolName); err != nil {
		return err
	}

	// path param organization_id
	if err := r.SetPathParam("organization_id", o.OrganizationID); err != nil {
		return err
	}

	// path param project_id
	if err := r.SetPathParam("project_id", o.ProjectID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
