// Code generated by go-swagger; DO NOT EDIT.

package secret_service

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewGetAppParams creates a new GetAppParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewGetAppParams() *GetAppParams {
	return &GetAppParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewGetAppParamsWithTimeout creates a new GetAppParams object
// with the ability to set a timeout on a request.
func NewGetAppParamsWithTimeout(timeout time.Duration) *GetAppParams {
	return &GetAppParams{
		timeout: timeout,
	}
}

// NewGetAppParamsWithContext creates a new GetAppParams object
// with the ability to set a context for a request.
func NewGetAppParamsWithContext(ctx context.Context) *GetAppParams {
	return &GetAppParams{
		Context: ctx,
	}
}

// NewGetAppParamsWithHTTPClient creates a new GetAppParams object
// with the ability to set a custom HTTPClient for a request.
func NewGetAppParamsWithHTTPClient(client *http.Client) *GetAppParams {
	return &GetAppParams{
		HTTPClient: client,
	}
}

/*
GetAppParams contains all the parameters to send to the API endpoint

	for the get app operation.

	Typically these are written to a http.Request.
*/
type GetAppParams struct {

	// Name.
	Name string

	// OrganizationID.
	OrganizationID string

	// ProjectID.
	ProjectID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the get app params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetAppParams) WithDefaults() *GetAppParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the get app params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetAppParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the get app params
func (o *GetAppParams) WithTimeout(timeout time.Duration) *GetAppParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get app params
func (o *GetAppParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get app params
func (o *GetAppParams) WithContext(ctx context.Context) *GetAppParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get app params
func (o *GetAppParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get app params
func (o *GetAppParams) WithHTTPClient(client *http.Client) *GetAppParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get app params
func (o *GetAppParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithName adds the name to the get app params
func (o *GetAppParams) WithName(name string) *GetAppParams {
	o.SetName(name)
	return o
}

// SetName adds the name to the get app params
func (o *GetAppParams) SetName(name string) {
	o.Name = name
}

// WithOrganizationID adds the organizationID to the get app params
func (o *GetAppParams) WithOrganizationID(organizationID string) *GetAppParams {
	o.SetOrganizationID(organizationID)
	return o
}

// SetOrganizationID adds the organizationId to the get app params
func (o *GetAppParams) SetOrganizationID(organizationID string) {
	o.OrganizationID = organizationID
}

// WithProjectID adds the projectID to the get app params
func (o *GetAppParams) WithProjectID(projectID string) *GetAppParams {
	o.SetProjectID(projectID)
	return o
}

// SetProjectID adds the projectId to the get app params
func (o *GetAppParams) SetProjectID(projectID string) {
	o.ProjectID = projectID
}

// WriteToRequest writes these params to a swagger request
func (o *GetAppParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param name
	if err := r.SetPathParam("name", o.Name); err != nil {
		return err
	}

	// path param organization_id
	if err := r.SetPathParam("organization_id", o.OrganizationID); err != nil {
		return err
	}

	// path param project_id
	if err := r.SetPathParam("project_id", o.ProjectID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
