// Code generated by go-swagger; DO NOT EDIT.

package secret_service

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewGetConfluentIntegrationParams creates a new GetConfluentIntegrationParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewGetConfluentIntegrationParams() *GetConfluentIntegrationParams {
	return &GetConfluentIntegrationParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewGetConfluentIntegrationParamsWithTimeout creates a new GetConfluentIntegrationParams object
// with the ability to set a timeout on a request.
func NewGetConfluentIntegrationParamsWithTimeout(timeout time.Duration) *GetConfluentIntegrationParams {
	return &GetConfluentIntegrationParams{
		timeout: timeout,
	}
}

// NewGetConfluentIntegrationParamsWithContext creates a new GetConfluentIntegrationParams object
// with the ability to set a context for a request.
func NewGetConfluentIntegrationParamsWithContext(ctx context.Context) *GetConfluentIntegrationParams {
	return &GetConfluentIntegrationParams{
		Context: ctx,
	}
}

// NewGetConfluentIntegrationParamsWithHTTPClient creates a new GetConfluentIntegrationParams object
// with the ability to set a custom HTTPClient for a request.
func NewGetConfluentIntegrationParamsWithHTTPClient(client *http.Client) *GetConfluentIntegrationParams {
	return &GetConfluentIntegrationParams{
		HTTPClient: client,
	}
}

/*
GetConfluentIntegrationParams contains all the parameters to send to the API endpoint

	for the get confluent integration operation.

	Typically these are written to a http.Request.
*/
type GetConfluentIntegrationParams struct {

	// Name.
	Name string

	// OrganizationID.
	OrganizationID string

	// ProjectID.
	ProjectID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the get confluent integration params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetConfluentIntegrationParams) WithDefaults() *GetConfluentIntegrationParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the get confluent integration params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetConfluentIntegrationParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the get confluent integration params
func (o *GetConfluentIntegrationParams) WithTimeout(timeout time.Duration) *GetConfluentIntegrationParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get confluent integration params
func (o *GetConfluentIntegrationParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get confluent integration params
func (o *GetConfluentIntegrationParams) WithContext(ctx context.Context) *GetConfluentIntegrationParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get confluent integration params
func (o *GetConfluentIntegrationParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get confluent integration params
func (o *GetConfluentIntegrationParams) WithHTTPClient(client *http.Client) *GetConfluentIntegrationParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get confluent integration params
func (o *GetConfluentIntegrationParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithName adds the name to the get confluent integration params
func (o *GetConfluentIntegrationParams) WithName(name string) *GetConfluentIntegrationParams {
	o.SetName(name)
	return o
}

// SetName adds the name to the get confluent integration params
func (o *GetConfluentIntegrationParams) SetName(name string) {
	o.Name = name
}

// WithOrganizationID adds the organizationID to the get confluent integration params
func (o *GetConfluentIntegrationParams) WithOrganizationID(organizationID string) *GetConfluentIntegrationParams {
	o.SetOrganizationID(organizationID)
	return o
}

// SetOrganizationID adds the organizationId to the get confluent integration params
func (o *GetConfluentIntegrationParams) SetOrganizationID(organizationID string) {
	o.OrganizationID = organizationID
}

// WithProjectID adds the projectID to the get confluent integration params
func (o *GetConfluentIntegrationParams) WithProjectID(projectID string) *GetConfluentIntegrationParams {
	o.SetProjectID(projectID)
	return o
}

// SetProjectID adds the projectId to the get confluent integration params
func (o *GetConfluentIntegrationParams) SetProjectID(projectID string) {
	o.ProjectID = projectID
}

// WriteToRequest writes these params to a swagger request
func (o *GetConfluentIntegrationParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param name
	if err := r.SetPathParam("name", o.Name); err != nil {
		return err
	}

	// path param organization_id
	if err := r.SetPathParam("organization_id", o.OrganizationID); err != nil {
		return err
	}

	// path param project_id
	if err := r.SetPathParam("project_id", o.ProjectID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
