// Code generated by go-swagger; DO NOT EDIT.

package secret_service

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewGetGcpDynamicSecretParams creates a new GetGcpDynamicSecretParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewGetGcpDynamicSecretParams() *GetGcpDynamicSecretParams {
	return &GetGcpDynamicSecretParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewGetGcpDynamicSecretParamsWithTimeout creates a new GetGcpDynamicSecretParams object
// with the ability to set a timeout on a request.
func NewGetGcpDynamicSecretParamsWithTimeout(timeout time.Duration) *GetGcpDynamicSecretParams {
	return &GetGcpDynamicSecretParams{
		timeout: timeout,
	}
}

// NewGetGcpDynamicSecretParamsWithContext creates a new GetGcpDynamicSecretParams object
// with the ability to set a context for a request.
func NewGetGcpDynamicSecretParamsWithContext(ctx context.Context) *GetGcpDynamicSecretParams {
	return &GetGcpDynamicSecretParams{
		Context: ctx,
	}
}

// NewGetGcpDynamicSecretParamsWithHTTPClient creates a new GetGcpDynamicSecretParams object
// with the ability to set a custom HTTPClient for a request.
func NewGetGcpDynamicSecretParamsWithHTTPClient(client *http.Client) *GetGcpDynamicSecretParams {
	return &GetGcpDynamicSecretParams{
		HTTPClient: client,
	}
}

/*
GetGcpDynamicSecretParams contains all the parameters to send to the API endpoint

	for the get gcp dynamic secret operation.

	Typically these are written to a http.Request.
*/
type GetGcpDynamicSecretParams struct {

	// AppName.
	AppName string

	// Name.
	Name string

	// OrganizationID.
	OrganizationID string

	// ProjectID.
	ProjectID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the get gcp dynamic secret params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetGcpDynamicSecretParams) WithDefaults() *GetGcpDynamicSecretParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the get gcp dynamic secret params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetGcpDynamicSecretParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the get gcp dynamic secret params
func (o *GetGcpDynamicSecretParams) WithTimeout(timeout time.Duration) *GetGcpDynamicSecretParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get gcp dynamic secret params
func (o *GetGcpDynamicSecretParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get gcp dynamic secret params
func (o *GetGcpDynamicSecretParams) WithContext(ctx context.Context) *GetGcpDynamicSecretParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get gcp dynamic secret params
func (o *GetGcpDynamicSecretParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get gcp dynamic secret params
func (o *GetGcpDynamicSecretParams) WithHTTPClient(client *http.Client) *GetGcpDynamicSecretParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get gcp dynamic secret params
func (o *GetGcpDynamicSecretParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithAppName adds the appName to the get gcp dynamic secret params
func (o *GetGcpDynamicSecretParams) WithAppName(appName string) *GetGcpDynamicSecretParams {
	o.SetAppName(appName)
	return o
}

// SetAppName adds the appName to the get gcp dynamic secret params
func (o *GetGcpDynamicSecretParams) SetAppName(appName string) {
	o.AppName = appName
}

// WithName adds the name to the get gcp dynamic secret params
func (o *GetGcpDynamicSecretParams) WithName(name string) *GetGcpDynamicSecretParams {
	o.SetName(name)
	return o
}

// SetName adds the name to the get gcp dynamic secret params
func (o *GetGcpDynamicSecretParams) SetName(name string) {
	o.Name = name
}

// WithOrganizationID adds the organizationID to the get gcp dynamic secret params
func (o *GetGcpDynamicSecretParams) WithOrganizationID(organizationID string) *GetGcpDynamicSecretParams {
	o.SetOrganizationID(organizationID)
	return o
}

// SetOrganizationID adds the organizationId to the get gcp dynamic secret params
func (o *GetGcpDynamicSecretParams) SetOrganizationID(organizationID string) {
	o.OrganizationID = organizationID
}

// WithProjectID adds the projectID to the get gcp dynamic secret params
func (o *GetGcpDynamicSecretParams) WithProjectID(projectID string) *GetGcpDynamicSecretParams {
	o.SetProjectID(projectID)
	return o
}

// SetProjectID adds the projectId to the get gcp dynamic secret params
func (o *GetGcpDynamicSecretParams) SetProjectID(projectID string) {
	o.ProjectID = projectID
}

// WriteToRequest writes these params to a swagger request
func (o *GetGcpDynamicSecretParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param app_name
	if err := r.SetPathParam("app_name", o.AppName); err != nil {
		return err
	}

	// path param name
	if err := r.SetPathParam("name", o.Name); err != nil {
		return err
	}

	// path param organization_id
	if err := r.SetPathParam("organization_id", o.OrganizationID); err != nil {
		return err
	}

	// path param project_id
	if err := r.SetPathParam("project_id", o.ProjectID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
