// Code generated by go-swagger; DO NOT EDIT.

package secret_service

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewGetUsageParams creates a new GetUsageParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewGetUsageParams() *GetUsageParams {
	return &GetUsageParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewGetUsageParamsWithTimeout creates a new GetUsageParams object
// with the ability to set a timeout on a request.
func NewGetUsageParamsWithTimeout(timeout time.Duration) *GetUsageParams {
	return &GetUsageParams{
		timeout: timeout,
	}
}

// NewGetUsageParamsWithContext creates a new GetUsageParams object
// with the ability to set a context for a request.
func NewGetUsageParamsWithContext(ctx context.Context) *GetUsageParams {
	return &GetUsageParams{
		Context: ctx,
	}
}

// NewGetUsageParamsWithHTTPClient creates a new GetUsageParams object
// with the ability to set a custom HTTPClient for a request.
func NewGetUsageParamsWithHTTPClient(client *http.Client) *GetUsageParams {
	return &GetUsageParams{
		HTTPClient: client,
	}
}

/*
GetUsageParams contains all the parameters to send to the API endpoint

	for the get usage operation.

	Typically these are written to a http.Request.
*/
type GetUsageParams struct {

	// OrganizationID.
	OrganizationID string

	// ProjectID.
	ProjectID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the get usage params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetUsageParams) WithDefaults() *GetUsageParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the get usage params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetUsageParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the get usage params
func (o *GetUsageParams) WithTimeout(timeout time.Duration) *GetUsageParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get usage params
func (o *GetUsageParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get usage params
func (o *GetUsageParams) WithContext(ctx context.Context) *GetUsageParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get usage params
func (o *GetUsageParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get usage params
func (o *GetUsageParams) WithHTTPClient(client *http.Client) *GetUsageParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get usage params
func (o *GetUsageParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithOrganizationID adds the organizationID to the get usage params
func (o *GetUsageParams) WithOrganizationID(organizationID string) *GetUsageParams {
	o.SetOrganizationID(organizationID)
	return o
}

// SetOrganizationID adds the organizationId to the get usage params
func (o *GetUsageParams) SetOrganizationID(organizationID string) {
	o.OrganizationID = organizationID
}

// WithProjectID adds the projectID to the get usage params
func (o *GetUsageParams) WithProjectID(projectID string) *GetUsageParams {
	o.SetProjectID(projectID)
	return o
}

// SetProjectID adds the projectId to the get usage params
func (o *GetUsageParams) SetProjectID(projectID string) {
	o.ProjectID = projectID
}

// WriteToRequest writes these params to a swagger request
func (o *GetUsageParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param organization_id
	if err := r.SetPathParam("organization_id", o.OrganizationID); err != nil {
		return err
	}

	// path param project_id
	if err := r.SetPathParam("project_id", o.ProjectID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
