// Code generated by go-swagger; DO NOT EDIT.

package secret_service

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewListGatewayPoolGatewaysParams creates a new ListGatewayPoolGatewaysParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewListGatewayPoolGatewaysParams() *ListGatewayPoolGatewaysParams {
	return &ListGatewayPoolGatewaysParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewListGatewayPoolGatewaysParamsWithTimeout creates a new ListGatewayPoolGatewaysParams object
// with the ability to set a timeout on a request.
func NewListGatewayPoolGatewaysParamsWithTimeout(timeout time.Duration) *ListGatewayPoolGatewaysParams {
	return &ListGatewayPoolGatewaysParams{
		timeout: timeout,
	}
}

// NewListGatewayPoolGatewaysParamsWithContext creates a new ListGatewayPoolGatewaysParams object
// with the ability to set a context for a request.
func NewListGatewayPoolGatewaysParamsWithContext(ctx context.Context) *ListGatewayPoolGatewaysParams {
	return &ListGatewayPoolGatewaysParams{
		Context: ctx,
	}
}

// NewListGatewayPoolGatewaysParamsWithHTTPClient creates a new ListGatewayPoolGatewaysParams object
// with the ability to set a custom HTTPClient for a request.
func NewListGatewayPoolGatewaysParamsWithHTTPClient(client *http.Client) *ListGatewayPoolGatewaysParams {
	return &ListGatewayPoolGatewaysParams{
		HTTPClient: client,
	}
}

/*
ListGatewayPoolGatewaysParams contains all the parameters to send to the API endpoint

	for the list gateway pool gateways operation.

	Typically these are written to a http.Request.
*/
type ListGatewayPoolGatewaysParams struct {

	// GatewayPoolName.
	GatewayPoolName string

	// OrganizationID.
	OrganizationID string

	// ProjectID.
	ProjectID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the list gateway pool gateways params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ListGatewayPoolGatewaysParams) WithDefaults() *ListGatewayPoolGatewaysParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the list gateway pool gateways params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ListGatewayPoolGatewaysParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the list gateway pool gateways params
func (o *ListGatewayPoolGatewaysParams) WithTimeout(timeout time.Duration) *ListGatewayPoolGatewaysParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the list gateway pool gateways params
func (o *ListGatewayPoolGatewaysParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the list gateway pool gateways params
func (o *ListGatewayPoolGatewaysParams) WithContext(ctx context.Context) *ListGatewayPoolGatewaysParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the list gateway pool gateways params
func (o *ListGatewayPoolGatewaysParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the list gateway pool gateways params
func (o *ListGatewayPoolGatewaysParams) WithHTTPClient(client *http.Client) *ListGatewayPoolGatewaysParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the list gateway pool gateways params
func (o *ListGatewayPoolGatewaysParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithGatewayPoolName adds the gatewayPoolName to the list gateway pool gateways params
func (o *ListGatewayPoolGatewaysParams) WithGatewayPoolName(gatewayPoolName string) *ListGatewayPoolGatewaysParams {
	o.SetGatewayPoolName(gatewayPoolName)
	return o
}

// SetGatewayPoolName adds the gatewayPoolName to the list gateway pool gateways params
func (o *ListGatewayPoolGatewaysParams) SetGatewayPoolName(gatewayPoolName string) {
	o.GatewayPoolName = gatewayPoolName
}

// WithOrganizationID adds the organizationID to the list gateway pool gateways params
func (o *ListGatewayPoolGatewaysParams) WithOrganizationID(organizationID string) *ListGatewayPoolGatewaysParams {
	o.SetOrganizationID(organizationID)
	return o
}

// SetOrganizationID adds the organizationId to the list gateway pool gateways params
func (o *ListGatewayPoolGatewaysParams) SetOrganizationID(organizationID string) {
	o.OrganizationID = organizationID
}

// WithProjectID adds the projectID to the list gateway pool gateways params
func (o *ListGatewayPoolGatewaysParams) WithProjectID(projectID string) *ListGatewayPoolGatewaysParams {
	o.SetProjectID(projectID)
	return o
}

// SetProjectID adds the projectId to the list gateway pool gateways params
func (o *ListGatewayPoolGatewaysParams) SetProjectID(projectID string) {
	o.ProjectID = projectID
}

// WriteToRequest writes these params to a swagger request
func (o *ListGatewayPoolGatewaysParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param gateway_pool_name
	if err := r.SetPathParam("gateway_pool_name", o.GatewayPoolName); err != nil {
		return err
	}

	// path param organization_id
	if err := r.SetPathParam("organization_id", o.OrganizationID); err != nil {
		return err
	}

	// path param project_id
	if err := r.SetPathParam("project_id", o.ProjectID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
