// Code generated by go-swagger; DO NOT EDIT.

package secret_service

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/hashicorp/hcp-sdk-go/clients/cloud-vault-secrets/stable/2023-11-28/models"
)

// NewUpdateGcpDynamicSecretParams creates a new UpdateGcpDynamicSecretParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewUpdateGcpDynamicSecretParams() *UpdateGcpDynamicSecretParams {
	return &UpdateGcpDynamicSecretParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewUpdateGcpDynamicSecretParamsWithTimeout creates a new UpdateGcpDynamicSecretParams object
// with the ability to set a timeout on a request.
func NewUpdateGcpDynamicSecretParamsWithTimeout(timeout time.Duration) *UpdateGcpDynamicSecretParams {
	return &UpdateGcpDynamicSecretParams{
		timeout: timeout,
	}
}

// NewUpdateGcpDynamicSecretParamsWithContext creates a new UpdateGcpDynamicSecretParams object
// with the ability to set a context for a request.
func NewUpdateGcpDynamicSecretParamsWithContext(ctx context.Context) *UpdateGcpDynamicSecretParams {
	return &UpdateGcpDynamicSecretParams{
		Context: ctx,
	}
}

// NewUpdateGcpDynamicSecretParamsWithHTTPClient creates a new UpdateGcpDynamicSecretParams object
// with the ability to set a custom HTTPClient for a request.
func NewUpdateGcpDynamicSecretParamsWithHTTPClient(client *http.Client) *UpdateGcpDynamicSecretParams {
	return &UpdateGcpDynamicSecretParams{
		HTTPClient: client,
	}
}

/*
UpdateGcpDynamicSecretParams contains all the parameters to send to the API endpoint

	for the update gcp dynamic secret operation.

	Typically these are written to a http.Request.
*/
type UpdateGcpDynamicSecretParams struct {

	// AppName.
	AppName string

	// Body.
	Body *models.SecretServiceUpdateGcpDynamicSecretBody

	// Name.
	Name string

	// OrganizationID.
	OrganizationID string

	// ProjectID.
	ProjectID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the update gcp dynamic secret params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UpdateGcpDynamicSecretParams) WithDefaults() *UpdateGcpDynamicSecretParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the update gcp dynamic secret params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UpdateGcpDynamicSecretParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the update gcp dynamic secret params
func (o *UpdateGcpDynamicSecretParams) WithTimeout(timeout time.Duration) *UpdateGcpDynamicSecretParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the update gcp dynamic secret params
func (o *UpdateGcpDynamicSecretParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the update gcp dynamic secret params
func (o *UpdateGcpDynamicSecretParams) WithContext(ctx context.Context) *UpdateGcpDynamicSecretParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the update gcp dynamic secret params
func (o *UpdateGcpDynamicSecretParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the update gcp dynamic secret params
func (o *UpdateGcpDynamicSecretParams) WithHTTPClient(client *http.Client) *UpdateGcpDynamicSecretParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the update gcp dynamic secret params
func (o *UpdateGcpDynamicSecretParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithAppName adds the appName to the update gcp dynamic secret params
func (o *UpdateGcpDynamicSecretParams) WithAppName(appName string) *UpdateGcpDynamicSecretParams {
	o.SetAppName(appName)
	return o
}

// SetAppName adds the appName to the update gcp dynamic secret params
func (o *UpdateGcpDynamicSecretParams) SetAppName(appName string) {
	o.AppName = appName
}

// WithBody adds the body to the update gcp dynamic secret params
func (o *UpdateGcpDynamicSecretParams) WithBody(body *models.SecretServiceUpdateGcpDynamicSecretBody) *UpdateGcpDynamicSecretParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the update gcp dynamic secret params
func (o *UpdateGcpDynamicSecretParams) SetBody(body *models.SecretServiceUpdateGcpDynamicSecretBody) {
	o.Body = body
}

// WithName adds the name to the update gcp dynamic secret params
func (o *UpdateGcpDynamicSecretParams) WithName(name string) *UpdateGcpDynamicSecretParams {
	o.SetName(name)
	return o
}

// SetName adds the name to the update gcp dynamic secret params
func (o *UpdateGcpDynamicSecretParams) SetName(name string) {
	o.Name = name
}

// WithOrganizationID adds the organizationID to the update gcp dynamic secret params
func (o *UpdateGcpDynamicSecretParams) WithOrganizationID(organizationID string) *UpdateGcpDynamicSecretParams {
	o.SetOrganizationID(organizationID)
	return o
}

// SetOrganizationID adds the organizationId to the update gcp dynamic secret params
func (o *UpdateGcpDynamicSecretParams) SetOrganizationID(organizationID string) {
	o.OrganizationID = organizationID
}

// WithProjectID adds the projectID to the update gcp dynamic secret params
func (o *UpdateGcpDynamicSecretParams) WithProjectID(projectID string) *UpdateGcpDynamicSecretParams {
	o.SetProjectID(projectID)
	return o
}

// SetProjectID adds the projectId to the update gcp dynamic secret params
func (o *UpdateGcpDynamicSecretParams) SetProjectID(projectID string) {
	o.ProjectID = projectID
}

// WriteToRequest writes these params to a swagger request
func (o *UpdateGcpDynamicSecretParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param app_name
	if err := r.SetPathParam("app_name", o.AppName); err != nil {
		return err
	}
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	// path param name
	if err := r.SetPathParam("name", o.Name); err != nil {
		return err
	}

	// path param organization_id
	if err := r.SetPathParam("organization_id", o.OrganizationID); err != nil {
		return err
	}

	// path param project_id
	if err := r.SetPathParam("project_id", o.ProjectID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
