// Code generated by go-swagger; DO NOT EDIT.

package secret_service

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/hashicorp/hcp-sdk-go/clients/cloud-vault-secrets/stable/2023-11-28/models"
)

// NewUpdatePostgresRotatingSecretParams creates a new UpdatePostgresRotatingSecretParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewUpdatePostgresRotatingSecretParams() *UpdatePostgresRotatingSecretParams {
	return &UpdatePostgresRotatingSecretParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewUpdatePostgresRotatingSecretParamsWithTimeout creates a new UpdatePostgresRotatingSecretParams object
// with the ability to set a timeout on a request.
func NewUpdatePostgresRotatingSecretParamsWithTimeout(timeout time.Duration) *UpdatePostgresRotatingSecretParams {
	return &UpdatePostgresRotatingSecretParams{
		timeout: timeout,
	}
}

// NewUpdatePostgresRotatingSecretParamsWithContext creates a new UpdatePostgresRotatingSecretParams object
// with the ability to set a context for a request.
func NewUpdatePostgresRotatingSecretParamsWithContext(ctx context.Context) *UpdatePostgresRotatingSecretParams {
	return &UpdatePostgresRotatingSecretParams{
		Context: ctx,
	}
}

// NewUpdatePostgresRotatingSecretParamsWithHTTPClient creates a new UpdatePostgresRotatingSecretParams object
// with the ability to set a custom HTTPClient for a request.
func NewUpdatePostgresRotatingSecretParamsWithHTTPClient(client *http.Client) *UpdatePostgresRotatingSecretParams {
	return &UpdatePostgresRotatingSecretParams{
		HTTPClient: client,
	}
}

/*
UpdatePostgresRotatingSecretParams contains all the parameters to send to the API endpoint

	for the update postgres rotating secret operation.

	Typically these are written to a http.Request.
*/
type UpdatePostgresRotatingSecretParams struct {

	// AppName.
	AppName string

	// Body.
	Body *models.SecretServiceUpdatePostgresRotatingSecretBody

	// Name.
	Name string

	// OrganizationID.
	OrganizationID string

	// ProjectID.
	ProjectID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the update postgres rotating secret params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UpdatePostgresRotatingSecretParams) WithDefaults() *UpdatePostgresRotatingSecretParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the update postgres rotating secret params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UpdatePostgresRotatingSecretParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the update postgres rotating secret params
func (o *UpdatePostgresRotatingSecretParams) WithTimeout(timeout time.Duration) *UpdatePostgresRotatingSecretParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the update postgres rotating secret params
func (o *UpdatePostgresRotatingSecretParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the update postgres rotating secret params
func (o *UpdatePostgresRotatingSecretParams) WithContext(ctx context.Context) *UpdatePostgresRotatingSecretParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the update postgres rotating secret params
func (o *UpdatePostgresRotatingSecretParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the update postgres rotating secret params
func (o *UpdatePostgresRotatingSecretParams) WithHTTPClient(client *http.Client) *UpdatePostgresRotatingSecretParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the update postgres rotating secret params
func (o *UpdatePostgresRotatingSecretParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithAppName adds the appName to the update postgres rotating secret params
func (o *UpdatePostgresRotatingSecretParams) WithAppName(appName string) *UpdatePostgresRotatingSecretParams {
	o.SetAppName(appName)
	return o
}

// SetAppName adds the appName to the update postgres rotating secret params
func (o *UpdatePostgresRotatingSecretParams) SetAppName(appName string) {
	o.AppName = appName
}

// WithBody adds the body to the update postgres rotating secret params
func (o *UpdatePostgresRotatingSecretParams) WithBody(body *models.SecretServiceUpdatePostgresRotatingSecretBody) *UpdatePostgresRotatingSecretParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the update postgres rotating secret params
func (o *UpdatePostgresRotatingSecretParams) SetBody(body *models.SecretServiceUpdatePostgresRotatingSecretBody) {
	o.Body = body
}

// WithName adds the name to the update postgres rotating secret params
func (o *UpdatePostgresRotatingSecretParams) WithName(name string) *UpdatePostgresRotatingSecretParams {
	o.SetName(name)
	return o
}

// SetName adds the name to the update postgres rotating secret params
func (o *UpdatePostgresRotatingSecretParams) SetName(name string) {
	o.Name = name
}

// WithOrganizationID adds the organizationID to the update postgres rotating secret params
func (o *UpdatePostgresRotatingSecretParams) WithOrganizationID(organizationID string) *UpdatePostgresRotatingSecretParams {
	o.SetOrganizationID(organizationID)
	return o
}

// SetOrganizationID adds the organizationId to the update postgres rotating secret params
func (o *UpdatePostgresRotatingSecretParams) SetOrganizationID(organizationID string) {
	o.OrganizationID = organizationID
}

// WithProjectID adds the projectID to the update postgres rotating secret params
func (o *UpdatePostgresRotatingSecretParams) WithProjectID(projectID string) *UpdatePostgresRotatingSecretParams {
	o.SetProjectID(projectID)
	return o
}

// SetProjectID adds the projectId to the update postgres rotating secret params
func (o *UpdatePostgresRotatingSecretParams) SetProjectID(projectID string) {
	o.ProjectID = projectID
}

// WriteToRequest writes these params to a swagger request
func (o *UpdatePostgresRotatingSecretParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param app_name
	if err := r.SetPathParam("app_name", o.AppName); err != nil {
		return err
	}
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	// path param name
	if err := r.SetPathParam("name", o.Name); err != nil {
		return err
	}

	// path param organization_id
	if err := r.SetPathParam("organization_id", o.OrganizationID); err != nil {
		return err
	}

	// path param project_id
	if err := r.SetPathParam("project_id", o.ProjectID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
