// Code generated by go-swagger; DO NOT EDIT.

package secret_service

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/hashicorp/hcp-sdk-go/clients/cloud-vault-secrets/stable/2023-11-28/models"
)

// NewUpdateTwilioIntegrationParams creates a new UpdateTwilioIntegrationParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewUpdateTwilioIntegrationParams() *UpdateTwilioIntegrationParams {
	return &UpdateTwilioIntegrationParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewUpdateTwilioIntegrationParamsWithTimeout creates a new UpdateTwilioIntegrationParams object
// with the ability to set a timeout on a request.
func NewUpdateTwilioIntegrationParamsWithTimeout(timeout time.Duration) *UpdateTwilioIntegrationParams {
	return &UpdateTwilioIntegrationParams{
		timeout: timeout,
	}
}

// NewUpdateTwilioIntegrationParamsWithContext creates a new UpdateTwilioIntegrationParams object
// with the ability to set a context for a request.
func NewUpdateTwilioIntegrationParamsWithContext(ctx context.Context) *UpdateTwilioIntegrationParams {
	return &UpdateTwilioIntegrationParams{
		Context: ctx,
	}
}

// NewUpdateTwilioIntegrationParamsWithHTTPClient creates a new UpdateTwilioIntegrationParams object
// with the ability to set a custom HTTPClient for a request.
func NewUpdateTwilioIntegrationParamsWithHTTPClient(client *http.Client) *UpdateTwilioIntegrationParams {
	return &UpdateTwilioIntegrationParams{
		HTTPClient: client,
	}
}

/*
UpdateTwilioIntegrationParams contains all the parameters to send to the API endpoint

	for the update twilio integration operation.

	Typically these are written to a http.Request.
*/
type UpdateTwilioIntegrationParams struct {

	// Body.
	Body *models.SecretServiceUpdateTwilioIntegrationBody

	// Name.
	Name string

	// OrganizationID.
	OrganizationID string

	// ProjectID.
	ProjectID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the update twilio integration params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UpdateTwilioIntegrationParams) WithDefaults() *UpdateTwilioIntegrationParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the update twilio integration params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UpdateTwilioIntegrationParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the update twilio integration params
func (o *UpdateTwilioIntegrationParams) WithTimeout(timeout time.Duration) *UpdateTwilioIntegrationParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the update twilio integration params
func (o *UpdateTwilioIntegrationParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the update twilio integration params
func (o *UpdateTwilioIntegrationParams) WithContext(ctx context.Context) *UpdateTwilioIntegrationParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the update twilio integration params
func (o *UpdateTwilioIntegrationParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the update twilio integration params
func (o *UpdateTwilioIntegrationParams) WithHTTPClient(client *http.Client) *UpdateTwilioIntegrationParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the update twilio integration params
func (o *UpdateTwilioIntegrationParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the update twilio integration params
func (o *UpdateTwilioIntegrationParams) WithBody(body *models.SecretServiceUpdateTwilioIntegrationBody) *UpdateTwilioIntegrationParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the update twilio integration params
func (o *UpdateTwilioIntegrationParams) SetBody(body *models.SecretServiceUpdateTwilioIntegrationBody) {
	o.Body = body
}

// WithName adds the name to the update twilio integration params
func (o *UpdateTwilioIntegrationParams) WithName(name string) *UpdateTwilioIntegrationParams {
	o.SetName(name)
	return o
}

// SetName adds the name to the update twilio integration params
func (o *UpdateTwilioIntegrationParams) SetName(name string) {
	o.Name = name
}

// WithOrganizationID adds the organizationID to the update twilio integration params
func (o *UpdateTwilioIntegrationParams) WithOrganizationID(organizationID string) *UpdateTwilioIntegrationParams {
	o.SetOrganizationID(organizationID)
	return o
}

// SetOrganizationID adds the organizationId to the update twilio integration params
func (o *UpdateTwilioIntegrationParams) SetOrganizationID(organizationID string) {
	o.OrganizationID = organizationID
}

// WithProjectID adds the projectID to the update twilio integration params
func (o *UpdateTwilioIntegrationParams) WithProjectID(projectID string) *UpdateTwilioIntegrationParams {
	o.SetProjectID(projectID)
	return o
}

// SetProjectID adds the projectId to the update twilio integration params
func (o *UpdateTwilioIntegrationParams) SetProjectID(projectID string) {
	o.ProjectID = projectID
}

// WriteToRequest writes these params to a swagger request
func (o *UpdateTwilioIntegrationParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	// path param name
	if err := r.SetPathParam("name", o.Name); err != nil {
		return err
	}

	// path param organization_id
	if err := r.SetPathParam("organization_id", o.OrganizationID); err != nil {
		return err
	}

	// path param project_id
	if err := r.SetPathParam("project_id", o.ProjectID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
