// Code generated by go-swagger; DO NOT EDIT.

package secret_service

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/hashicorp/hcp-sdk-go/clients/cloud-vault-secrets/stable/2023-11-28/models"
)

// NewUpdateTwilioRotatingSecretParams creates a new UpdateTwilioRotatingSecretParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewUpdateTwilioRotatingSecretParams() *UpdateTwilioRotatingSecretParams {
	return &UpdateTwilioRotatingSecretParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewUpdateTwilioRotatingSecretParamsWithTimeout creates a new UpdateTwilioRotatingSecretParams object
// with the ability to set a timeout on a request.
func NewUpdateTwilioRotatingSecretParamsWithTimeout(timeout time.Duration) *UpdateTwilioRotatingSecretParams {
	return &UpdateTwilioRotatingSecretParams{
		timeout: timeout,
	}
}

// NewUpdateTwilioRotatingSecretParamsWithContext creates a new UpdateTwilioRotatingSecretParams object
// with the ability to set a context for a request.
func NewUpdateTwilioRotatingSecretParamsWithContext(ctx context.Context) *UpdateTwilioRotatingSecretParams {
	return &UpdateTwilioRotatingSecretParams{
		Context: ctx,
	}
}

// NewUpdateTwilioRotatingSecretParamsWithHTTPClient creates a new UpdateTwilioRotatingSecretParams object
// with the ability to set a custom HTTPClient for a request.
func NewUpdateTwilioRotatingSecretParamsWithHTTPClient(client *http.Client) *UpdateTwilioRotatingSecretParams {
	return &UpdateTwilioRotatingSecretParams{
		HTTPClient: client,
	}
}

/*
UpdateTwilioRotatingSecretParams contains all the parameters to send to the API endpoint

	for the update twilio rotating secret operation.

	Typically these are written to a http.Request.
*/
type UpdateTwilioRotatingSecretParams struct {

	// AppName.
	AppName string

	// Body.
	Body *models.SecretServiceUpdateTwilioRotatingSecretBody

	// Name.
	Name string

	// OrganizationID.
	OrganizationID string

	// ProjectID.
	ProjectID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the update twilio rotating secret params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UpdateTwilioRotatingSecretParams) WithDefaults() *UpdateTwilioRotatingSecretParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the update twilio rotating secret params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UpdateTwilioRotatingSecretParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the update twilio rotating secret params
func (o *UpdateTwilioRotatingSecretParams) WithTimeout(timeout time.Duration) *UpdateTwilioRotatingSecretParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the update twilio rotating secret params
func (o *UpdateTwilioRotatingSecretParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the update twilio rotating secret params
func (o *UpdateTwilioRotatingSecretParams) WithContext(ctx context.Context) *UpdateTwilioRotatingSecretParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the update twilio rotating secret params
func (o *UpdateTwilioRotatingSecretParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the update twilio rotating secret params
func (o *UpdateTwilioRotatingSecretParams) WithHTTPClient(client *http.Client) *UpdateTwilioRotatingSecretParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the update twilio rotating secret params
func (o *UpdateTwilioRotatingSecretParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithAppName adds the appName to the update twilio rotating secret params
func (o *UpdateTwilioRotatingSecretParams) WithAppName(appName string) *UpdateTwilioRotatingSecretParams {
	o.SetAppName(appName)
	return o
}

// SetAppName adds the appName to the update twilio rotating secret params
func (o *UpdateTwilioRotatingSecretParams) SetAppName(appName string) {
	o.AppName = appName
}

// WithBody adds the body to the update twilio rotating secret params
func (o *UpdateTwilioRotatingSecretParams) WithBody(body *models.SecretServiceUpdateTwilioRotatingSecretBody) *UpdateTwilioRotatingSecretParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the update twilio rotating secret params
func (o *UpdateTwilioRotatingSecretParams) SetBody(body *models.SecretServiceUpdateTwilioRotatingSecretBody) {
	o.Body = body
}

// WithName adds the name to the update twilio rotating secret params
func (o *UpdateTwilioRotatingSecretParams) WithName(name string) *UpdateTwilioRotatingSecretParams {
	o.SetName(name)
	return o
}

// SetName adds the name to the update twilio rotating secret params
func (o *UpdateTwilioRotatingSecretParams) SetName(name string) {
	o.Name = name
}

// WithOrganizationID adds the organizationID to the update twilio rotating secret params
func (o *UpdateTwilioRotatingSecretParams) WithOrganizationID(organizationID string) *UpdateTwilioRotatingSecretParams {
	o.SetOrganizationID(organizationID)
	return o
}

// SetOrganizationID adds the organizationId to the update twilio rotating secret params
func (o *UpdateTwilioRotatingSecretParams) SetOrganizationID(organizationID string) {
	o.OrganizationID = organizationID
}

// WithProjectID adds the projectID to the update twilio rotating secret params
func (o *UpdateTwilioRotatingSecretParams) WithProjectID(projectID string) *UpdateTwilioRotatingSecretParams {
	o.SetProjectID(projectID)
	return o
}

// SetProjectID adds the projectId to the update twilio rotating secret params
func (o *UpdateTwilioRotatingSecretParams) SetProjectID(projectID string) {
	o.ProjectID = projectID
}

// WriteToRequest writes these params to a swagger request
func (o *UpdateTwilioRotatingSecretParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param app_name
	if err := r.SetPathParam("app_name", o.AppName); err != nil {
		return err
	}
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	// path param name
	if err := r.SetPathParam("name", o.Name); err != nil {
		return err
	}

	// path param organization_id
	if err := r.SetPathParam("organization_id", o.OrganizationID); err != nil {
		return err
	}

	// path param project_id
	if err := r.SetPathParam("project_id", o.ProjectID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
