// Code generated by go-swagger; DO NOT EDIT.

package models

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"
)

// Secrets20231128OpenSecret secrets 20231128 open secret
//
// swagger:model secrets_20231128OpenSecret
type Secrets20231128OpenSecret struct {

	// created at
	// Format: date-time
	CreatedAt strfmt.DateTime `json:"created_at,omitempty"`

	// created by id
	CreatedByID string `json:"created_by_id,omitempty"`

	// dynamic instance
	DynamicInstance *Secrets20231128OpenSecretDynamicInstance `json:"dynamic_instance,omitempty"`

	// latest version
	LatestVersion int64 `json:"latest_version,omitempty"`

	// name
	Name string `json:"name,omitempty"`

	// provider
	Provider string `json:"provider,omitempty"`

	// rotating version
	RotatingVersion *Secrets20231128OpenSecretRotatingVersion `json:"rotating_version,omitempty"`

	// static version
	StaticVersion *Secrets20231128OpenSecretStaticVersion `json:"static_version,omitempty"`

	// sync status
	SyncStatus map[string]Secrets20231128SyncStatus `json:"sync_status,omitempty"`

	// type
	Type string `json:"type,omitempty"`
}

// Validate validates this secrets 20231128 open secret
func (m *Secrets20231128OpenSecret) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateCreatedAt(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateDynamicInstance(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateRotatingVersion(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateStaticVersion(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateSyncStatus(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *Secrets20231128OpenSecret) validateCreatedAt(formats strfmt.Registry) error {
	if swag.IsZero(m.CreatedAt) { // not required
		return nil
	}

	if err := validate.FormatOf("created_at", "body", "date-time", m.CreatedAt.String(), formats); err != nil {
		return err
	}

	return nil
}

func (m *Secrets20231128OpenSecret) validateDynamicInstance(formats strfmt.Registry) error {
	if swag.IsZero(m.DynamicInstance) { // not required
		return nil
	}

	if m.DynamicInstance != nil {
		if err := m.DynamicInstance.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("dynamic_instance")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("dynamic_instance")
			}
			return err
		}
	}

	return nil
}

func (m *Secrets20231128OpenSecret) validateRotatingVersion(formats strfmt.Registry) error {
	if swag.IsZero(m.RotatingVersion) { // not required
		return nil
	}

	if m.RotatingVersion != nil {
		if err := m.RotatingVersion.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("rotating_version")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("rotating_version")
			}
			return err
		}
	}

	return nil
}

func (m *Secrets20231128OpenSecret) validateStaticVersion(formats strfmt.Registry) error {
	if swag.IsZero(m.StaticVersion) { // not required
		return nil
	}

	if m.StaticVersion != nil {
		if err := m.StaticVersion.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("static_version")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("static_version")
			}
			return err
		}
	}

	return nil
}

func (m *Secrets20231128OpenSecret) validateSyncStatus(formats strfmt.Registry) error {
	if swag.IsZero(m.SyncStatus) { // not required
		return nil
	}

	for k := range m.SyncStatus {

		if err := validate.Required("sync_status"+"."+k, "body", m.SyncStatus[k]); err != nil {
			return err
		}
		if val, ok := m.SyncStatus[k]; ok {
			if err := val.Validate(formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("sync_status" + "." + k)
				} else if ce, ok := err.(*errors.CompositeError); ok {
					return ce.ValidateName("sync_status" + "." + k)
				}
				return err
			}
		}

	}

	return nil
}

// ContextValidate validate this secrets 20231128 open secret based on the context it is used
func (m *Secrets20231128OpenSecret) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateDynamicInstance(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateRotatingVersion(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateStaticVersion(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateSyncStatus(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *Secrets20231128OpenSecret) contextValidateDynamicInstance(ctx context.Context, formats strfmt.Registry) error {

	if m.DynamicInstance != nil {

		if swag.IsZero(m.DynamicInstance) { // not required
			return nil
		}

		if err := m.DynamicInstance.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("dynamic_instance")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("dynamic_instance")
			}
			return err
		}
	}

	return nil
}

func (m *Secrets20231128OpenSecret) contextValidateRotatingVersion(ctx context.Context, formats strfmt.Registry) error {

	if m.RotatingVersion != nil {

		if swag.IsZero(m.RotatingVersion) { // not required
			return nil
		}

		if err := m.RotatingVersion.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("rotating_version")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("rotating_version")
			}
			return err
		}
	}

	return nil
}

func (m *Secrets20231128OpenSecret) contextValidateStaticVersion(ctx context.Context, formats strfmt.Registry) error {

	if m.StaticVersion != nil {

		if swag.IsZero(m.StaticVersion) { // not required
			return nil
		}

		if err := m.StaticVersion.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("static_version")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("static_version")
			}
			return err
		}
	}

	return nil
}

func (m *Secrets20231128OpenSecret) contextValidateSyncStatus(ctx context.Context, formats strfmt.Registry) error {

	for k := range m.SyncStatus {

		if val, ok := m.SyncStatus[k]; ok {
			if err := val.ContextValidate(ctx, formats); err != nil {
				return err
			}
		}

	}

	return nil
}

// MarshalBinary interface implementation
func (m *Secrets20231128OpenSecret) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *Secrets20231128OpenSecret) UnmarshalBinary(b []byte) error {
	var res Secrets20231128OpenSecret
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
