// Code generated by go-swagger; DO NOT EDIT.

package waypoint_service

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewWaypointServiceDestroyApplicationParams creates a new WaypointServiceDestroyApplicationParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewWaypointServiceDestroyApplicationParams() *WaypointServiceDestroyApplicationParams {
	return &WaypointServiceDestroyApplicationParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewWaypointServiceDestroyApplicationParamsWithTimeout creates a new WaypointServiceDestroyApplicationParams object
// with the ability to set a timeout on a request.
func NewWaypointServiceDestroyApplicationParamsWithTimeout(timeout time.Duration) *WaypointServiceDestroyApplicationParams {
	return &WaypointServiceDestroyApplicationParams{
		timeout: timeout,
	}
}

// NewWaypointServiceDestroyApplicationParamsWithContext creates a new WaypointServiceDestroyApplicationParams object
// with the ability to set a context for a request.
func NewWaypointServiceDestroyApplicationParamsWithContext(ctx context.Context) *WaypointServiceDestroyApplicationParams {
	return &WaypointServiceDestroyApplicationParams{
		Context: ctx,
	}
}

// NewWaypointServiceDestroyApplicationParamsWithHTTPClient creates a new WaypointServiceDestroyApplicationParams object
// with the ability to set a custom HTTPClient for a request.
func NewWaypointServiceDestroyApplicationParamsWithHTTPClient(client *http.Client) *WaypointServiceDestroyApplicationParams {
	return &WaypointServiceDestroyApplicationParams{
		HTTPClient: client,
	}
}

/*
WaypointServiceDestroyApplicationParams contains all the parameters to send to the API endpoint

	for the waypoint service destroy application operation.

	Typically these are written to a http.Request.
*/
type WaypointServiceDestroyApplicationParams struct {

	// ApplicationID.
	ApplicationID string

	// ApplicationName.
	ApplicationName *string

	// NamespaceID.
	NamespaceID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the waypoint service destroy application params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *WaypointServiceDestroyApplicationParams) WithDefaults() *WaypointServiceDestroyApplicationParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the waypoint service destroy application params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *WaypointServiceDestroyApplicationParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the waypoint service destroy application params
func (o *WaypointServiceDestroyApplicationParams) WithTimeout(timeout time.Duration) *WaypointServiceDestroyApplicationParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the waypoint service destroy application params
func (o *WaypointServiceDestroyApplicationParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the waypoint service destroy application params
func (o *WaypointServiceDestroyApplicationParams) WithContext(ctx context.Context) *WaypointServiceDestroyApplicationParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the waypoint service destroy application params
func (o *WaypointServiceDestroyApplicationParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the waypoint service destroy application params
func (o *WaypointServiceDestroyApplicationParams) WithHTTPClient(client *http.Client) *WaypointServiceDestroyApplicationParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the waypoint service destroy application params
func (o *WaypointServiceDestroyApplicationParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithApplicationID adds the applicationID to the waypoint service destroy application params
func (o *WaypointServiceDestroyApplicationParams) WithApplicationID(applicationID string) *WaypointServiceDestroyApplicationParams {
	o.SetApplicationID(applicationID)
	return o
}

// SetApplicationID adds the applicationId to the waypoint service destroy application params
func (o *WaypointServiceDestroyApplicationParams) SetApplicationID(applicationID string) {
	o.ApplicationID = applicationID
}

// WithApplicationName adds the applicationName to the waypoint service destroy application params
func (o *WaypointServiceDestroyApplicationParams) WithApplicationName(applicationName *string) *WaypointServiceDestroyApplicationParams {
	o.SetApplicationName(applicationName)
	return o
}

// SetApplicationName adds the applicationName to the waypoint service destroy application params
func (o *WaypointServiceDestroyApplicationParams) SetApplicationName(applicationName *string) {
	o.ApplicationName = applicationName
}

// WithNamespaceID adds the namespaceID to the waypoint service destroy application params
func (o *WaypointServiceDestroyApplicationParams) WithNamespaceID(namespaceID string) *WaypointServiceDestroyApplicationParams {
	o.SetNamespaceID(namespaceID)
	return o
}

// SetNamespaceID adds the namespaceId to the waypoint service destroy application params
func (o *WaypointServiceDestroyApplicationParams) SetNamespaceID(namespaceID string) {
	o.NamespaceID = namespaceID
}

// WriteToRequest writes these params to a swagger request
func (o *WaypointServiceDestroyApplicationParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param application.id
	if err := r.SetPathParam("application.id", o.ApplicationID); err != nil {
		return err
	}

	if o.ApplicationName != nil {

		// query param application.name
		var qrApplicationName string

		if o.ApplicationName != nil {
			qrApplicationName = *o.ApplicationName
		}
		qApplicationName := qrApplicationName
		if qApplicationName != "" {

			if err := r.SetQueryParam("application.name", qApplicationName); err != nil {
				return err
			}
		}
	}

	// path param namespace.id
	if err := r.SetPathParam("namespace.id", o.NamespaceID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
