// Code generated by go-swagger; DO NOT EDIT.

package waypoint_service

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewWaypointServiceGetActionConfigParams creates a new WaypointServiceGetActionConfigParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewWaypointServiceGetActionConfigParams() *WaypointServiceGetActionConfigParams {
	return &WaypointServiceGetActionConfigParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewWaypointServiceGetActionConfigParamsWithTimeout creates a new WaypointServiceGetActionConfigParams object
// with the ability to set a timeout on a request.
func NewWaypointServiceGetActionConfigParamsWithTimeout(timeout time.Duration) *WaypointServiceGetActionConfigParams {
	return &WaypointServiceGetActionConfigParams{
		timeout: timeout,
	}
}

// NewWaypointServiceGetActionConfigParamsWithContext creates a new WaypointServiceGetActionConfigParams object
// with the ability to set a context for a request.
func NewWaypointServiceGetActionConfigParamsWithContext(ctx context.Context) *WaypointServiceGetActionConfigParams {
	return &WaypointServiceGetActionConfigParams{
		Context: ctx,
	}
}

// NewWaypointServiceGetActionConfigParamsWithHTTPClient creates a new WaypointServiceGetActionConfigParams object
// with the ability to set a custom HTTPClient for a request.
func NewWaypointServiceGetActionConfigParamsWithHTTPClient(client *http.Client) *WaypointServiceGetActionConfigParams {
	return &WaypointServiceGetActionConfigParams{
		HTTPClient: client,
	}
}

/*
WaypointServiceGetActionConfigParams contains all the parameters to send to the API endpoint

	for the waypoint service get action config operation.

	Typically these are written to a http.Request.
*/
type WaypointServiceGetActionConfigParams struct {

	/* ActionID.

	   The id of the action config being requested
	*/
	ActionID *string

	/* ActionName.

	   The name of the action being requested (will only be used if id not provided)
	*/
	ActionName *string

	// NamespaceID.
	NamespaceID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the waypoint service get action config params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *WaypointServiceGetActionConfigParams) WithDefaults() *WaypointServiceGetActionConfigParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the waypoint service get action config params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *WaypointServiceGetActionConfigParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the waypoint service get action config params
func (o *WaypointServiceGetActionConfigParams) WithTimeout(timeout time.Duration) *WaypointServiceGetActionConfigParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the waypoint service get action config params
func (o *WaypointServiceGetActionConfigParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the waypoint service get action config params
func (o *WaypointServiceGetActionConfigParams) WithContext(ctx context.Context) *WaypointServiceGetActionConfigParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the waypoint service get action config params
func (o *WaypointServiceGetActionConfigParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the waypoint service get action config params
func (o *WaypointServiceGetActionConfigParams) WithHTTPClient(client *http.Client) *WaypointServiceGetActionConfigParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the waypoint service get action config params
func (o *WaypointServiceGetActionConfigParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithActionID adds the actionID to the waypoint service get action config params
func (o *WaypointServiceGetActionConfigParams) WithActionID(actionID *string) *WaypointServiceGetActionConfigParams {
	o.SetActionID(actionID)
	return o
}

// SetActionID adds the actionId to the waypoint service get action config params
func (o *WaypointServiceGetActionConfigParams) SetActionID(actionID *string) {
	o.ActionID = actionID
}

// WithActionName adds the actionName to the waypoint service get action config params
func (o *WaypointServiceGetActionConfigParams) WithActionName(actionName *string) *WaypointServiceGetActionConfigParams {
	o.SetActionName(actionName)
	return o
}

// SetActionName adds the actionName to the waypoint service get action config params
func (o *WaypointServiceGetActionConfigParams) SetActionName(actionName *string) {
	o.ActionName = actionName
}

// WithNamespaceID adds the namespaceID to the waypoint service get action config params
func (o *WaypointServiceGetActionConfigParams) WithNamespaceID(namespaceID string) *WaypointServiceGetActionConfigParams {
	o.SetNamespaceID(namespaceID)
	return o
}

// SetNamespaceID adds the namespaceId to the waypoint service get action config params
func (o *WaypointServiceGetActionConfigParams) SetNamespaceID(namespaceID string) {
	o.NamespaceID = namespaceID
}

// WriteToRequest writes these params to a swagger request
func (o *WaypointServiceGetActionConfigParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.ActionID != nil {

		// query param action_id
		var qrActionID string

		if o.ActionID != nil {
			qrActionID = *o.ActionID
		}
		qActionID := qrActionID
		if qActionID != "" {

			if err := r.SetQueryParam("action_id", qActionID); err != nil {
				return err
			}
		}
	}

	if o.ActionName != nil {

		// query param action_name
		var qrActionName string

		if o.ActionName != nil {
			qrActionName = *o.ActionName
		}
		qActionName := qrActionName
		if qActionName != "" {

			if err := r.SetQueryParam("action_name", qActionName); err != nil {
				return err
			}
		}
	}

	// path param namespace.id
	if err := r.SetPathParam("namespace.id", o.NamespaceID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
