// Code generated by go-swagger; DO NOT EDIT.

package waypoint_service

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewWaypointServiceGetApplicationTemplateParams creates a new WaypointServiceGetApplicationTemplateParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewWaypointServiceGetApplicationTemplateParams() *WaypointServiceGetApplicationTemplateParams {
	return &WaypointServiceGetApplicationTemplateParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewWaypointServiceGetApplicationTemplateParamsWithTimeout creates a new WaypointServiceGetApplicationTemplateParams object
// with the ability to set a timeout on a request.
func NewWaypointServiceGetApplicationTemplateParamsWithTimeout(timeout time.Duration) *WaypointServiceGetApplicationTemplateParams {
	return &WaypointServiceGetApplicationTemplateParams{
		timeout: timeout,
	}
}

// NewWaypointServiceGetApplicationTemplateParamsWithContext creates a new WaypointServiceGetApplicationTemplateParams object
// with the ability to set a context for a request.
func NewWaypointServiceGetApplicationTemplateParamsWithContext(ctx context.Context) *WaypointServiceGetApplicationTemplateParams {
	return &WaypointServiceGetApplicationTemplateParams{
		Context: ctx,
	}
}

// NewWaypointServiceGetApplicationTemplateParamsWithHTTPClient creates a new WaypointServiceGetApplicationTemplateParams object
// with the ability to set a custom HTTPClient for a request.
func NewWaypointServiceGetApplicationTemplateParamsWithHTTPClient(client *http.Client) *WaypointServiceGetApplicationTemplateParams {
	return &WaypointServiceGetApplicationTemplateParams{
		HTTPClient: client,
	}
}

/*
WaypointServiceGetApplicationTemplateParams contains all the parameters to send to the API endpoint

	for the waypoint service get application template operation.

	Typically these are written to a http.Request.
*/
type WaypointServiceGetApplicationTemplateParams struct {

	/* ApplicationTemplateID.

	   ID of the ApplicationTemplate
	*/
	ApplicationTemplateID string

	/* ApplicationTemplateName.

	   Name of the ApplicationTemplate
	*/
	ApplicationTemplateName *string

	// NamespaceID.
	NamespaceID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the waypoint service get application template params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *WaypointServiceGetApplicationTemplateParams) WithDefaults() *WaypointServiceGetApplicationTemplateParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the waypoint service get application template params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *WaypointServiceGetApplicationTemplateParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the waypoint service get application template params
func (o *WaypointServiceGetApplicationTemplateParams) WithTimeout(timeout time.Duration) *WaypointServiceGetApplicationTemplateParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the waypoint service get application template params
func (o *WaypointServiceGetApplicationTemplateParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the waypoint service get application template params
func (o *WaypointServiceGetApplicationTemplateParams) WithContext(ctx context.Context) *WaypointServiceGetApplicationTemplateParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the waypoint service get application template params
func (o *WaypointServiceGetApplicationTemplateParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the waypoint service get application template params
func (o *WaypointServiceGetApplicationTemplateParams) WithHTTPClient(client *http.Client) *WaypointServiceGetApplicationTemplateParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the waypoint service get application template params
func (o *WaypointServiceGetApplicationTemplateParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithApplicationTemplateID adds the applicationTemplateID to the waypoint service get application template params
func (o *WaypointServiceGetApplicationTemplateParams) WithApplicationTemplateID(applicationTemplateID string) *WaypointServiceGetApplicationTemplateParams {
	o.SetApplicationTemplateID(applicationTemplateID)
	return o
}

// SetApplicationTemplateID adds the applicationTemplateId to the waypoint service get application template params
func (o *WaypointServiceGetApplicationTemplateParams) SetApplicationTemplateID(applicationTemplateID string) {
	o.ApplicationTemplateID = applicationTemplateID
}

// WithApplicationTemplateName adds the applicationTemplateName to the waypoint service get application template params
func (o *WaypointServiceGetApplicationTemplateParams) WithApplicationTemplateName(applicationTemplateName *string) *WaypointServiceGetApplicationTemplateParams {
	o.SetApplicationTemplateName(applicationTemplateName)
	return o
}

// SetApplicationTemplateName adds the applicationTemplateName to the waypoint service get application template params
func (o *WaypointServiceGetApplicationTemplateParams) SetApplicationTemplateName(applicationTemplateName *string) {
	o.ApplicationTemplateName = applicationTemplateName
}

// WithNamespaceID adds the namespaceID to the waypoint service get application template params
func (o *WaypointServiceGetApplicationTemplateParams) WithNamespaceID(namespaceID string) *WaypointServiceGetApplicationTemplateParams {
	o.SetNamespaceID(namespaceID)
	return o
}

// SetNamespaceID adds the namespaceId to the waypoint service get application template params
func (o *WaypointServiceGetApplicationTemplateParams) SetNamespaceID(namespaceID string) {
	o.NamespaceID = namespaceID
}

// WriteToRequest writes these params to a swagger request
func (o *WaypointServiceGetApplicationTemplateParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param application_template.id
	if err := r.SetPathParam("application_template.id", o.ApplicationTemplateID); err != nil {
		return err
	}

	if o.ApplicationTemplateName != nil {

		// query param application_template.name
		var qrApplicationTemplateName string

		if o.ApplicationTemplateName != nil {
			qrApplicationTemplateName = *o.ApplicationTemplateName
		}
		qApplicationTemplateName := qrApplicationTemplateName
		if qApplicationTemplateName != "" {

			if err := r.SetQueryParam("application_template.name", qApplicationTemplateName); err != nil {
				return err
			}
		}
	}

	// path param namespace.id
	if err := r.SetPathParam("namespace.id", o.NamespaceID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
