// Code generated by go-swagger; DO NOT EDIT.

package waypoint_service

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewWaypointServiceListActionConfigsParams creates a new WaypointServiceListActionConfigsParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewWaypointServiceListActionConfigsParams() *WaypointServiceListActionConfigsParams {
	return &WaypointServiceListActionConfigsParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewWaypointServiceListActionConfigsParamsWithTimeout creates a new WaypointServiceListActionConfigsParams object
// with the ability to set a timeout on a request.
func NewWaypointServiceListActionConfigsParamsWithTimeout(timeout time.Duration) *WaypointServiceListActionConfigsParams {
	return &WaypointServiceListActionConfigsParams{
		timeout: timeout,
	}
}

// NewWaypointServiceListActionConfigsParamsWithContext creates a new WaypointServiceListActionConfigsParams object
// with the ability to set a context for a request.
func NewWaypointServiceListActionConfigsParamsWithContext(ctx context.Context) *WaypointServiceListActionConfigsParams {
	return &WaypointServiceListActionConfigsParams{
		Context: ctx,
	}
}

// NewWaypointServiceListActionConfigsParamsWithHTTPClient creates a new WaypointServiceListActionConfigsParams object
// with the ability to set a custom HTTPClient for a request.
func NewWaypointServiceListActionConfigsParamsWithHTTPClient(client *http.Client) *WaypointServiceListActionConfigsParams {
	return &WaypointServiceListActionConfigsParams{
		HTTPClient: client,
	}
}

/*
WaypointServiceListActionConfigsParams contains all the parameters to send to the API endpoint

	for the waypoint service list action configs operation.

	Typically these are written to a http.Request.
*/
type WaypointServiceListActionConfigsParams struct {

	// NamespaceID.
	NamespaceID string

	/* PaginationNextPageToken.

	     Specifies a page token to use to retrieve the next page. Set this to the
	`next_page_token` returned by previous list requests to get the next page of
	results. If set, `previous_page_token` must not be set.
	*/
	PaginationNextPageToken *string

	/* PaginationPageSize.

	     The max number of results per page that should be returned. If the number
	of available results is larger than `page_size`, a `next_page_token` is
	returned which can be used to get the next page of results in subsequent
	requests. A value of zero will cause `page_size` to be defaulted.

	     Format: int64
	*/
	PaginationPageSize *int64

	/* PaginationPreviousPageToken.

	     Specifies a page token to use to retrieve the previous page. Set this to
	the `previous_page_token` returned by previous list requests to get the
	previous page of results. If set, `next_page_token` must not be set.
	*/
	PaginationPreviousPageToken *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the waypoint service list action configs params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *WaypointServiceListActionConfigsParams) WithDefaults() *WaypointServiceListActionConfigsParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the waypoint service list action configs params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *WaypointServiceListActionConfigsParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the waypoint service list action configs params
func (o *WaypointServiceListActionConfigsParams) WithTimeout(timeout time.Duration) *WaypointServiceListActionConfigsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the waypoint service list action configs params
func (o *WaypointServiceListActionConfigsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the waypoint service list action configs params
func (o *WaypointServiceListActionConfigsParams) WithContext(ctx context.Context) *WaypointServiceListActionConfigsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the waypoint service list action configs params
func (o *WaypointServiceListActionConfigsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the waypoint service list action configs params
func (o *WaypointServiceListActionConfigsParams) WithHTTPClient(client *http.Client) *WaypointServiceListActionConfigsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the waypoint service list action configs params
func (o *WaypointServiceListActionConfigsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithNamespaceID adds the namespaceID to the waypoint service list action configs params
func (o *WaypointServiceListActionConfigsParams) WithNamespaceID(namespaceID string) *WaypointServiceListActionConfigsParams {
	o.SetNamespaceID(namespaceID)
	return o
}

// SetNamespaceID adds the namespaceId to the waypoint service list action configs params
func (o *WaypointServiceListActionConfigsParams) SetNamespaceID(namespaceID string) {
	o.NamespaceID = namespaceID
}

// WithPaginationNextPageToken adds the paginationNextPageToken to the waypoint service list action configs params
func (o *WaypointServiceListActionConfigsParams) WithPaginationNextPageToken(paginationNextPageToken *string) *WaypointServiceListActionConfigsParams {
	o.SetPaginationNextPageToken(paginationNextPageToken)
	return o
}

// SetPaginationNextPageToken adds the paginationNextPageToken to the waypoint service list action configs params
func (o *WaypointServiceListActionConfigsParams) SetPaginationNextPageToken(paginationNextPageToken *string) {
	o.PaginationNextPageToken = paginationNextPageToken
}

// WithPaginationPageSize adds the paginationPageSize to the waypoint service list action configs params
func (o *WaypointServiceListActionConfigsParams) WithPaginationPageSize(paginationPageSize *int64) *WaypointServiceListActionConfigsParams {
	o.SetPaginationPageSize(paginationPageSize)
	return o
}

// SetPaginationPageSize adds the paginationPageSize to the waypoint service list action configs params
func (o *WaypointServiceListActionConfigsParams) SetPaginationPageSize(paginationPageSize *int64) {
	o.PaginationPageSize = paginationPageSize
}

// WithPaginationPreviousPageToken adds the paginationPreviousPageToken to the waypoint service list action configs params
func (o *WaypointServiceListActionConfigsParams) WithPaginationPreviousPageToken(paginationPreviousPageToken *string) *WaypointServiceListActionConfigsParams {
	o.SetPaginationPreviousPageToken(paginationPreviousPageToken)
	return o
}

// SetPaginationPreviousPageToken adds the paginationPreviousPageToken to the waypoint service list action configs params
func (o *WaypointServiceListActionConfigsParams) SetPaginationPreviousPageToken(paginationPreviousPageToken *string) {
	o.PaginationPreviousPageToken = paginationPreviousPageToken
}

// WriteToRequest writes these params to a swagger request
func (o *WaypointServiceListActionConfigsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param namespace.id
	if err := r.SetPathParam("namespace.id", o.NamespaceID); err != nil {
		return err
	}

	if o.PaginationNextPageToken != nil {

		// query param pagination.next_page_token
		var qrPaginationNextPageToken string

		if o.PaginationNextPageToken != nil {
			qrPaginationNextPageToken = *o.PaginationNextPageToken
		}
		qPaginationNextPageToken := qrPaginationNextPageToken
		if qPaginationNextPageToken != "" {

			if err := r.SetQueryParam("pagination.next_page_token", qPaginationNextPageToken); err != nil {
				return err
			}
		}
	}

	if o.PaginationPageSize != nil {

		// query param pagination.page_size
		var qrPaginationPageSize int64

		if o.PaginationPageSize != nil {
			qrPaginationPageSize = *o.PaginationPageSize
		}
		qPaginationPageSize := swag.FormatInt64(qrPaginationPageSize)
		if qPaginationPageSize != "" {

			if err := r.SetQueryParam("pagination.page_size", qPaginationPageSize); err != nil {
				return err
			}
		}
	}

	if o.PaginationPreviousPageToken != nil {

		// query param pagination.previous_page_token
		var qrPaginationPreviousPageToken string

		if o.PaginationPreviousPageToken != nil {
			qrPaginationPreviousPageToken = *o.PaginationPreviousPageToken
		}
		qPaginationPreviousPageToken := qrPaginationPreviousPageToken
		if qPaginationPreviousPageToken != "" {

			if err := r.SetQueryParam("pagination.previous_page_token", qPaginationPreviousPageToken); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
