// Code generated by go-swagger; DO NOT EDIT.

package waypoint_service

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewWaypointServiceListActionRunsParams creates a new WaypointServiceListActionRunsParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewWaypointServiceListActionRunsParams() *WaypointServiceListActionRunsParams {
	return &WaypointServiceListActionRunsParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewWaypointServiceListActionRunsParamsWithTimeout creates a new WaypointServiceListActionRunsParams object
// with the ability to set a timeout on a request.
func NewWaypointServiceListActionRunsParamsWithTimeout(timeout time.Duration) *WaypointServiceListActionRunsParams {
	return &WaypointServiceListActionRunsParams{
		timeout: timeout,
	}
}

// NewWaypointServiceListActionRunsParamsWithContext creates a new WaypointServiceListActionRunsParams object
// with the ability to set a context for a request.
func NewWaypointServiceListActionRunsParamsWithContext(ctx context.Context) *WaypointServiceListActionRunsParams {
	return &WaypointServiceListActionRunsParams{
		Context: ctx,
	}
}

// NewWaypointServiceListActionRunsParamsWithHTTPClient creates a new WaypointServiceListActionRunsParams object
// with the ability to set a custom HTTPClient for a request.
func NewWaypointServiceListActionRunsParamsWithHTTPClient(client *http.Client) *WaypointServiceListActionRunsParams {
	return &WaypointServiceListActionRunsParams{
		HTTPClient: client,
	}
}

/*
WaypointServiceListActionRunsParams contains all the parameters to send to the API endpoint

	for the waypoint service list action runs operation.

	Typically these are written to a http.Request.
*/
type WaypointServiceListActionRunsParams struct {

	/* ActionID.

	   The id of the action config being listed
	*/
	ActionID string

	/* ActionName.

	   The name of the action being listed (will only be used if id not provided)
	*/
	ActionName *string

	// NamespaceID.
	NamespaceID string

	/* PaginationNextPageToken.

	     Specifies a page token to use to retrieve the next page. Set this to the
	`next_page_token` returned by previous list requests to get the next page of
	results. If set, `previous_page_token` must not be set.
	*/
	PaginationNextPageToken *string

	/* PaginationPageSize.

	     The max number of results per page that should be returned. If the number
	of available results is larger than `page_size`, a `next_page_token` is
	returned which can be used to get the next page of results in subsequent
	requests. A value of zero will cause `page_size` to be defaulted.

	     Format: int64
	*/
	PaginationPageSize *int64

	/* PaginationPreviousPageToken.

	     Specifies a page token to use to retrieve the previous page. Set this to
	the `previous_page_token` returned by previous list requests to get the
	previous page of results. If set, `next_page_token` must not be set.
	*/
	PaginationPreviousPageToken *string

	// ScopeApplicationID.
	ScopeApplicationID *string

	// ScopeApplicationName.
	ScopeApplicationName *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the waypoint service list action runs params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *WaypointServiceListActionRunsParams) WithDefaults() *WaypointServiceListActionRunsParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the waypoint service list action runs params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *WaypointServiceListActionRunsParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the waypoint service list action runs params
func (o *WaypointServiceListActionRunsParams) WithTimeout(timeout time.Duration) *WaypointServiceListActionRunsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the waypoint service list action runs params
func (o *WaypointServiceListActionRunsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the waypoint service list action runs params
func (o *WaypointServiceListActionRunsParams) WithContext(ctx context.Context) *WaypointServiceListActionRunsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the waypoint service list action runs params
func (o *WaypointServiceListActionRunsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the waypoint service list action runs params
func (o *WaypointServiceListActionRunsParams) WithHTTPClient(client *http.Client) *WaypointServiceListActionRunsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the waypoint service list action runs params
func (o *WaypointServiceListActionRunsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithActionID adds the actionID to the waypoint service list action runs params
func (o *WaypointServiceListActionRunsParams) WithActionID(actionID string) *WaypointServiceListActionRunsParams {
	o.SetActionID(actionID)
	return o
}

// SetActionID adds the actionId to the waypoint service list action runs params
func (o *WaypointServiceListActionRunsParams) SetActionID(actionID string) {
	o.ActionID = actionID
}

// WithActionName adds the actionName to the waypoint service list action runs params
func (o *WaypointServiceListActionRunsParams) WithActionName(actionName *string) *WaypointServiceListActionRunsParams {
	o.SetActionName(actionName)
	return o
}

// SetActionName adds the actionName to the waypoint service list action runs params
func (o *WaypointServiceListActionRunsParams) SetActionName(actionName *string) {
	o.ActionName = actionName
}

// WithNamespaceID adds the namespaceID to the waypoint service list action runs params
func (o *WaypointServiceListActionRunsParams) WithNamespaceID(namespaceID string) *WaypointServiceListActionRunsParams {
	o.SetNamespaceID(namespaceID)
	return o
}

// SetNamespaceID adds the namespaceId to the waypoint service list action runs params
func (o *WaypointServiceListActionRunsParams) SetNamespaceID(namespaceID string) {
	o.NamespaceID = namespaceID
}

// WithPaginationNextPageToken adds the paginationNextPageToken to the waypoint service list action runs params
func (o *WaypointServiceListActionRunsParams) WithPaginationNextPageToken(paginationNextPageToken *string) *WaypointServiceListActionRunsParams {
	o.SetPaginationNextPageToken(paginationNextPageToken)
	return o
}

// SetPaginationNextPageToken adds the paginationNextPageToken to the waypoint service list action runs params
func (o *WaypointServiceListActionRunsParams) SetPaginationNextPageToken(paginationNextPageToken *string) {
	o.PaginationNextPageToken = paginationNextPageToken
}

// WithPaginationPageSize adds the paginationPageSize to the waypoint service list action runs params
func (o *WaypointServiceListActionRunsParams) WithPaginationPageSize(paginationPageSize *int64) *WaypointServiceListActionRunsParams {
	o.SetPaginationPageSize(paginationPageSize)
	return o
}

// SetPaginationPageSize adds the paginationPageSize to the waypoint service list action runs params
func (o *WaypointServiceListActionRunsParams) SetPaginationPageSize(paginationPageSize *int64) {
	o.PaginationPageSize = paginationPageSize
}

// WithPaginationPreviousPageToken adds the paginationPreviousPageToken to the waypoint service list action runs params
func (o *WaypointServiceListActionRunsParams) WithPaginationPreviousPageToken(paginationPreviousPageToken *string) *WaypointServiceListActionRunsParams {
	o.SetPaginationPreviousPageToken(paginationPreviousPageToken)
	return o
}

// SetPaginationPreviousPageToken adds the paginationPreviousPageToken to the waypoint service list action runs params
func (o *WaypointServiceListActionRunsParams) SetPaginationPreviousPageToken(paginationPreviousPageToken *string) {
	o.PaginationPreviousPageToken = paginationPreviousPageToken
}

// WithScopeApplicationID adds the scopeApplicationID to the waypoint service list action runs params
func (o *WaypointServiceListActionRunsParams) WithScopeApplicationID(scopeApplicationID *string) *WaypointServiceListActionRunsParams {
	o.SetScopeApplicationID(scopeApplicationID)
	return o
}

// SetScopeApplicationID adds the scopeApplicationId to the waypoint service list action runs params
func (o *WaypointServiceListActionRunsParams) SetScopeApplicationID(scopeApplicationID *string) {
	o.ScopeApplicationID = scopeApplicationID
}

// WithScopeApplicationName adds the scopeApplicationName to the waypoint service list action runs params
func (o *WaypointServiceListActionRunsParams) WithScopeApplicationName(scopeApplicationName *string) *WaypointServiceListActionRunsParams {
	o.SetScopeApplicationName(scopeApplicationName)
	return o
}

// SetScopeApplicationName adds the scopeApplicationName to the waypoint service list action runs params
func (o *WaypointServiceListActionRunsParams) SetScopeApplicationName(scopeApplicationName *string) {
	o.ScopeApplicationName = scopeApplicationName
}

// WriteToRequest writes these params to a swagger request
func (o *WaypointServiceListActionRunsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param action_id
	if err := r.SetPathParam("action_id", o.ActionID); err != nil {
		return err
	}

	if o.ActionName != nil {

		// query param action_name
		var qrActionName string

		if o.ActionName != nil {
			qrActionName = *o.ActionName
		}
		qActionName := qrActionName
		if qActionName != "" {

			if err := r.SetQueryParam("action_name", qActionName); err != nil {
				return err
			}
		}
	}

	// path param namespace.id
	if err := r.SetPathParam("namespace.id", o.NamespaceID); err != nil {
		return err
	}

	if o.PaginationNextPageToken != nil {

		// query param pagination.next_page_token
		var qrPaginationNextPageToken string

		if o.PaginationNextPageToken != nil {
			qrPaginationNextPageToken = *o.PaginationNextPageToken
		}
		qPaginationNextPageToken := qrPaginationNextPageToken
		if qPaginationNextPageToken != "" {

			if err := r.SetQueryParam("pagination.next_page_token", qPaginationNextPageToken); err != nil {
				return err
			}
		}
	}

	if o.PaginationPageSize != nil {

		// query param pagination.page_size
		var qrPaginationPageSize int64

		if o.PaginationPageSize != nil {
			qrPaginationPageSize = *o.PaginationPageSize
		}
		qPaginationPageSize := swag.FormatInt64(qrPaginationPageSize)
		if qPaginationPageSize != "" {

			if err := r.SetQueryParam("pagination.page_size", qPaginationPageSize); err != nil {
				return err
			}
		}
	}

	if o.PaginationPreviousPageToken != nil {

		// query param pagination.previous_page_token
		var qrPaginationPreviousPageToken string

		if o.PaginationPreviousPageToken != nil {
			qrPaginationPreviousPageToken = *o.PaginationPreviousPageToken
		}
		qPaginationPreviousPageToken := qrPaginationPreviousPageToken
		if qPaginationPreviousPageToken != "" {

			if err := r.SetQueryParam("pagination.previous_page_token", qPaginationPreviousPageToken); err != nil {
				return err
			}
		}
	}

	if o.ScopeApplicationID != nil {

		// query param scope.application.id
		var qrScopeApplicationID string

		if o.ScopeApplicationID != nil {
			qrScopeApplicationID = *o.ScopeApplicationID
		}
		qScopeApplicationID := qrScopeApplicationID
		if qScopeApplicationID != "" {

			if err := r.SetQueryParam("scope.application.id", qScopeApplicationID); err != nil {
				return err
			}
		}
	}

	if o.ScopeApplicationName != nil {

		// query param scope.application.name
		var qrScopeApplicationName string

		if o.ScopeApplicationName != nil {
			qrScopeApplicationName = *o.ScopeApplicationName
		}
		qScopeApplicationName := qrScopeApplicationName
		if qScopeApplicationName != "" {

			if err := r.SetQueryParam("scope.application.name", qScopeApplicationName); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
