// Code generated by go-swagger; DO NOT EDIT.

package waypoint_service

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/hashicorp/hcp-sdk-go/clients/cloud-waypoint-service/preview/2023-08-18/models"
)

// NewWaypointServiceRetrieveAgentOperationParams creates a new WaypointServiceRetrieveAgentOperationParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewWaypointServiceRetrieveAgentOperationParams() *WaypointServiceRetrieveAgentOperationParams {
	return &WaypointServiceRetrieveAgentOperationParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewWaypointServiceRetrieveAgentOperationParamsWithTimeout creates a new WaypointServiceRetrieveAgentOperationParams object
// with the ability to set a timeout on a request.
func NewWaypointServiceRetrieveAgentOperationParamsWithTimeout(timeout time.Duration) *WaypointServiceRetrieveAgentOperationParams {
	return &WaypointServiceRetrieveAgentOperationParams{
		timeout: timeout,
	}
}

// NewWaypointServiceRetrieveAgentOperationParamsWithContext creates a new WaypointServiceRetrieveAgentOperationParams object
// with the ability to set a context for a request.
func NewWaypointServiceRetrieveAgentOperationParamsWithContext(ctx context.Context) *WaypointServiceRetrieveAgentOperationParams {
	return &WaypointServiceRetrieveAgentOperationParams{
		Context: ctx,
	}
}

// NewWaypointServiceRetrieveAgentOperationParamsWithHTTPClient creates a new WaypointServiceRetrieveAgentOperationParams object
// with the ability to set a custom HTTPClient for a request.
func NewWaypointServiceRetrieveAgentOperationParamsWithHTTPClient(client *http.Client) *WaypointServiceRetrieveAgentOperationParams {
	return &WaypointServiceRetrieveAgentOperationParams{
		HTTPClient: client,
	}
}

/*
WaypointServiceRetrieveAgentOperationParams contains all the parameters to send to the API endpoint

	for the waypoint service retrieve agent operation operation.

	Typically these are written to a http.Request.
*/
type WaypointServiceRetrieveAgentOperationParams struct {

	// Body.
	Body *models.HashicorpCloudWaypointWaypointServiceRetrieveAgentOperationBody

	// NamespaceID.
	NamespaceID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the waypoint service retrieve agent operation params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *WaypointServiceRetrieveAgentOperationParams) WithDefaults() *WaypointServiceRetrieveAgentOperationParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the waypoint service retrieve agent operation params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *WaypointServiceRetrieveAgentOperationParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the waypoint service retrieve agent operation params
func (o *WaypointServiceRetrieveAgentOperationParams) WithTimeout(timeout time.Duration) *WaypointServiceRetrieveAgentOperationParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the waypoint service retrieve agent operation params
func (o *WaypointServiceRetrieveAgentOperationParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the waypoint service retrieve agent operation params
func (o *WaypointServiceRetrieveAgentOperationParams) WithContext(ctx context.Context) *WaypointServiceRetrieveAgentOperationParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the waypoint service retrieve agent operation params
func (o *WaypointServiceRetrieveAgentOperationParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the waypoint service retrieve agent operation params
func (o *WaypointServiceRetrieveAgentOperationParams) WithHTTPClient(client *http.Client) *WaypointServiceRetrieveAgentOperationParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the waypoint service retrieve agent operation params
func (o *WaypointServiceRetrieveAgentOperationParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the waypoint service retrieve agent operation params
func (o *WaypointServiceRetrieveAgentOperationParams) WithBody(body *models.HashicorpCloudWaypointWaypointServiceRetrieveAgentOperationBody) *WaypointServiceRetrieveAgentOperationParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the waypoint service retrieve agent operation params
func (o *WaypointServiceRetrieveAgentOperationParams) SetBody(body *models.HashicorpCloudWaypointWaypointServiceRetrieveAgentOperationBody) {
	o.Body = body
}

// WithNamespaceID adds the namespaceID to the waypoint service retrieve agent operation params
func (o *WaypointServiceRetrieveAgentOperationParams) WithNamespaceID(namespaceID string) *WaypointServiceRetrieveAgentOperationParams {
	o.SetNamespaceID(namespaceID)
	return o
}

// SetNamespaceID adds the namespaceId to the waypoint service retrieve agent operation params
func (o *WaypointServiceRetrieveAgentOperationParams) SetNamespaceID(namespaceID string) {
	o.NamespaceID = namespaceID
}

// WriteToRequest writes these params to a swagger request
func (o *WaypointServiceRetrieveAgentOperationParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	// path param namespace.id
	if err := r.SetPathParam("namespace.id", o.NamespaceID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
